#include <assert.h>
#include "bitmap.h"
#include "ezwin.h"
#include "position.h"
#include "rect.h"
#include "circle.h"
#include "triangle.h"
#include "square.h"
#include "wobject.h"
#include "shape.h"
#include "label.h"

// Define  window
SimpleWindow windowptr("Shatranj", 40.0, 30.0, Position(0.0, 0.0));

// Defining a chess board
BitMap chessboard(windowptr);

//Defining the white pawns
BitMap wpawn1(windowptr);
BitMap wpawn2(windowptr);
BitMap wpawn3(windowptr);
BitMap wpawn4(windowptr);
BitMap wpawn5(windowptr);
BitMap wpawn6(windowptr);
BitMap wpawn7(windowptr);
BitMap wpawn8(windowptr);

//Defining the black pawns
BitMap bpawn1(windowptr);
BitMap bpawn2(windowptr);
BitMap bpawn3(windowptr);
BitMap bpawn4(windowptr);
BitMap bpawn5(windowptr);
BitMap bpawn6(windowptr);
BitMap bpawn7(windowptr);
BitMap bpawn8(windowptr);

//Defining white rooks
BitMap wrook1(windowptr);
BitMap wrook2(windowptr);

//Defining black rooks
BitMap brook1(windowptr);
BitMap brook2(windowptr);

//Defining white knights
BitMap wknight1(windowptr);
BitMap wknight2(windowptr);

//Defining black knights
BitMap bknight1(windowptr);
BitMap bknight2(windowptr);

//Defining white bishops
BitMap wbishopleft(windowptr);
BitMap wbishopright(windowptr);

//Defining black bishops
BitMap bbishopleft(windowptr);
BitMap bbishopright(windowptr);

//Defining queens
BitMap wqueen(windowptr);
BitMap bqueen(windowptr);

//Defining kings
BitMap wking(windowptr);
BitMap bking(windowptr);







//__________________________________________________________*******______________________________________________________//     

   /* Firstly, we are creating two arrays that stores center coordinates of
      black and white chesspieces respectively.
      The names are whitepiececenter and they are of data type position.
      Assuming the following convention

                pawn1=0
                pawn2=1
                pawn3=2
                pawn4=3
                pawn5=4
                pawn6=5
                pawn7=6
                pawn8=7
                king=8
                queen=9
                knight1=10
                knight2=11
                bishop1=12
                bishop2=13
                rook1=14
                rook2=15
   */


//_________________________________________________________*******_______________________________________________________//




//to define the datatype of an array board containing the centers of each cell of the chessboard
/*	
	class coordinate           
	{
		public:
		Position center;
		char hcor;
		int vcor;
	};
*/





//to define the datatype of arrays which store the possible movement to the pieces and then assign them checkstatus
	class newpos : public Position      
	{
	      public:
	      int checkstatus;
	};





    
	//defining global arrays
	Position board[8][8];
	Position whitepiececenter[16];
	Position blackpiececenter[16];
	Position place;
	int tell; int x=1;
	BitMap piece;


//_________________________________________________________________*****____________________________________________________//

//creating classes for each piece

	class wpawnmove                   //class for movement of white pawn
	{
		    public:    
		    BitMap obj;
		    int move;                                                      //move =0 pawn has not moved yet   move=1 pawn has moved atleast once 
		    int life;	                                                   //life =0 pawn is dead             life=1 pawn is alive
		    newpos surroundingblock[4];
		    newpos validmoves[4];
		    
		    //member functions
	       void initialise()             //function to store centers of surrounding blocks in an array
	       {
				 if(move==0) 
				 {
				   surroundingblock[0].SetXDistance(obj.GetXPosition()-2.0); 
				   surroundingblock[0].SetYDistance(obj.GetYPosition()-2.0); 
				   surroundingblock[1].SetXDistance(obj.GetXPosition()); 
				   surroundingblock[1].SetYDistance(obj.GetYPosition()-2.0);
				   surroundingblock[2].SetXDistance(obj.GetXPosition()+2.0);
				   surroundingblock[2].SetYDistance(obj.GetYPosition()-2.0);
				   surroundingblock[3].SetXDistance(obj.GetXPosition());
				   surroundingblock[3].SetYDistance(obj.GetYPosition()-2*2.0); 
				 }
				 else  if(move==1)
				 {
				   surroundingblock[0].SetXDistance(obj.GetXPosition()-2.0); 
				   surroundingblock[0].SetYDistance(obj.GetYPosition()-2.0); 
				   surroundingblock[1].SetXDistance(obj.GetXPosition()); 
				   surroundingblock[1].SetYDistance(obj.GetYPosition()-2.0);
				   surroundingblock[2].SetXDistance(obj.GetXPosition()+2.0);
				   surroundingblock[2].SetYDistance(obj.GetYPosition()-2.0);
				 }	
	       }


	      void checkposition()          //function to find whether surrounding pieces are occupied by friend piece, enemy piece or it is empty
	      {
				  if(move==0)       	        
				  {
						for(int c=0;c<4;c++)
						{
							surroundingblock[c].checkstatus=0;
							for(int i=0;i<8;i++)
							{
								for(int j=0;j<8;j++)
								{
									for(int k=0;k<16;k++)
									{
					 				  if(surroundingblock[c].GetXDistance()>1+(2*j) && surroundingblock[c].GetXDistance()<1+(2*(j+1)) && surroundingblock[c].GetYDistance()>0.5+(2*i) && surroundingblock[c].GetYDistance()<0.5+(2*(i+1))&& whitepiececenter[k].GetXDistance()>1+(2*j) && whitepiececenter[k].GetXDistance()<1+(2*(j+1)) && whitepiececenter[k].GetYDistance()>0.5+(2*i) && whitepiececenter[k].GetYDistance()<0.5+(2*(i+1)))
								   	{
									 surroundingblock[c].checkstatus=1;
									 break;
								   	}
								   else  if(surroundingblock[c].GetXDistance()>1+(2*j) && surroundingblock[c].GetXDistance()<1+(2*(j+1)) && surroundingblock[c].GetYDistance()>0.5+(2*i) && surroundingblock[c].GetYDistance()<0.5+(2*(i+1))&& blackpiececenter[k].GetXDistance()>1+(2*j) && blackpiececenter[k].GetXDistance()<1+(2*(j+1)) && blackpiececenter[k].GetYDistance()>0.5+(2*i) && blackpiececenter[k].GetYDistance()<0.5+(2*(i+1)))
								   	{
									 surroundingblock[c].checkstatus=2;
									 break;
								   	}
									}
								}
				  			}
						}
					}
				  else if(move==1)
				  {
						for(int c=0;c<3;c++)
						{
							
							surroundingblock[c].checkstatus=0;
							for(int i=0;i<8;i++)
							{
								for(int j=0;j<8;j++)
								{
									for(int k=0;k<16;k++)
									{
									   if(surroundingblock[c].GetXDistance()>1+(2*j) && surroundingblock[c].GetXDistance()<1+(2*(j+1)) && surroundingblock[c].GetYDistance()>0.5+(2*i) && surroundingblock[c].GetYDistance()<0.5+(2*(i+1))&& whitepiececenter[k].GetXDistance()>1+(2*j) && whitepiececenter[k].GetXDistance()<1+(2*(j+1)) && whitepiececenter[k].GetYDistance()>0.5+(2*i) && whitepiececenter[k].GetYDistance()<0.5+(2*(i+1)))
									   {
										 surroundingblock[c].checkstatus=1;
										 break;
									   }
									   else  if(surroundingblock[c].GetXDistance()>1+(2*j) && surroundingblock[c].GetXDistance()<1+(2*(j+1)) && surroundingblock[c].GetYDistance()>0.5+(2*i) && surroundingblock[c].GetYDistance()<0.5+(2*(i+1))&& blackpiececenter[k].GetXDistance()>1+(2*j) && blackpiececenter[k].GetXDistance()<1+(2*(j+1)) && blackpiececenter[k].GetYDistance()>0.5+(2*i) && blackpiececenter[k].GetYDistance()<0.5+(2*(i+1)))
									   {
										surroundingblock[c].checkstatus=2;
										break;
									   }
									}
								}
				 			}
						}
					} 
	      }//end of function checkposition

	      void validate()               //function to fill valid moves in an array
	      {
				  if(move==0)
				  { 
						if(surroundingblock[0].checkstatus==2)
						{
							//Position(validmoves[0])=Position(surroundingblock[0]);
							//validmoves[0].checkstatus=surroundingblock[0].checkstatus;  
							validmoves[0]=surroundingblock[0];
						}
						else
							validmoves[0].checkstatus=-1;
						if(surroundingblock[2].checkstatus==2)
						{
							//Position(validmoves[1])=Position(surroundingblock[2]);
							validmoves[1]=surroundingblock[2];
						}
						else
							validmoves[1].checkstatus=-1;
						if(surroundingblock[1].checkstatus==0)
						{           
							//Position(validmoves[2])=Position(surroundingblock[1]);
							validmoves[2]=surroundingblock[1];		                
							if(surroundingblock[3].checkstatus==0)
							{
								//Position(validmoves[3])=Position(surroundingblock[3]);
								validmoves[3]=surroundingblock[3];
							}
							else
								validmoves[3].checkstatus=-1;		        
						}
						else
							validmoves[2].checkstatus=-1;
				  }
				  else if(move==1) 
				  { 
						if(surroundingblock[0].checkstatus==2)
						{
							//Position(validmoves[0])=Position(surroundingblock[0]);
							validmoves[0]=surroundingblock[0];
						}
						else
							validmoves[0].checkstatus=-1;
						if(surroundingblock[2].checkstatus==2)
						{
							//Position(validmoves[1])=Position(surroundingblock[2]);
							validmoves[1]=surroundingblock[2];
						}
						else
							validmoves[1].checkstatus=-1;
						if(surroundingblock[1].checkstatus==0)
						{           
							//Position(validmoves[2])=Position(surroundingblock[1]);
							validmoves[2]=surroundingblock[1];
						}
						else
							validmoves[2].checkstatus=-1;
				  }
	      }//end of function validate
		      

	      int compare(Position ct)                  //this function finds out whetehr the click made lies in the valid moves or not
	      {
			  int flag=0;
			  if(move==1)
			  {
					for(int c=0;c<4;c++)
					{	
						if(validmoves[c].checkstatus!=-1)
						{
							for(int i=0;i<8;i++)
							{
								for(int j=0;j<8;j++)
								{
							if(ct.GetXDistance()>1+(2*j) && ct.GetXDistance()<1+(2*(j+1)) && ct.GetYDistance()>0.5+(2*i) && ct.GetYDistance()<0.5+(2*(i+1))&& validmoves[c].GetXDistance()>1+(2*j) && validmoves[c].GetXDistance()<1+(2*(j+1)) && validmoves[c].GetYDistance()>0.5+(2*i) && validmoves[c].GetYDistance()<0.5+(2*(i+1)))
							{
								if(validmoves[c].checkstatus==0)
								{
									flag=1;
									break;
								}
								else if(validmoves[c].checkstatus==2)
								{
									flag=2;
									break;
								}
							}
						}
					}	
			   }}}
			   else if(move==1)
			   {
					for(int c=0;c<3;c++)
					{
						if(validmoves[c].checkstatus!=-1)
						{
							for(int i=0;i<8;i++)
							{
								for(int j=0;j<8;j++)
								{
							if(ct.GetXDistance()>1+(2*j) && ct.GetXDistance()<1+(2*(j+1)) && ct.GetYDistance()>0.5+(2*i) && ct.GetYDistance()<0.5+(2*(i+1))&& validmoves[c].GetXDistance()>1+(2*j) && validmoves[c].GetXDistance()<1+(2*(j+1)) && validmoves[c].GetYDistance()>0.5+(2*i) && validmoves[c].GetYDistance()<0.5+(2*(i+1)))
							{
								if(validmoves[i].checkstatus==0)
								{
									flag=1;
									break;
								}
								else if(validmoves[i].checkstatus==2)
								{
									flag=3;
									break;
								}
							}
						}
					}	
			   }}}
			   return flag;	
	      }// end of function compare
		
	}wp1,wp2,wp3,wp4,wp5,wp6,wp7,wp8;      //creating 8 objects each corresponding to the individual white pawn



	class bpawnmove                      //class for movement of black pawn
	{ 
		    public:
		    BitMap obj;
		    int move;                                    //move=0 pawn has not moved yet         // move=1 pawn has moved atleast once
		    int life;	                                 //life =0 pawn is dead                  // life=1 pawn is alive
		    newpos surroundingblock[4];
		    newpos validmoves[4];
		    
		    //member functions
		       void initialise()                            ////function to store centers of surrounding blocks in an array
		       {
				 if(move==0) 
				 {
				   surroundingblock[0].SetXDistance(obj.GetXPosition()-2.0);   
				   surroundingblock[0].SetYDistance(obj.GetYPosition()+2.0); 
				   surroundingblock[1].SetXDistance(obj.GetXPosition()); 
				   surroundingblock[1].SetYDistance(obj.GetYPosition()+2.0);
				   surroundingblock[2].SetXDistance(obj.GetXPosition()+2.0);
				   surroundingblock[2].SetYDistance(obj.GetYPosition()-2.0);
				   surroundingblock[3].SetXDistance(obj.GetXPosition());
				   surroundingblock[3].SetYDistance(obj.GetYPosition()+2*2.0); 
				 }
				 else  if(move==1)
				 {
				   surroundingblock[0].SetXDistance(obj.GetXPosition()-2.0); 
				   surroundingblock[0].SetYDistance(obj.GetYPosition()+2.0); 
				   surroundingblock[1].SetXDistance(obj.GetXPosition()); 
				   surroundingblock[1].SetYDistance(obj.GetYPosition()+2.0);
				   surroundingblock[2].SetXDistance(obj.GetXPosition()+2.0);
				   surroundingblock[2].SetYDistance(obj.GetYPosition()+2.0);
		    	 	 }	
		       }//end of function initialise


		      void checkposition()                   //function to find whether surrounding pieces are occupied by friend piece, enemy piece or it is empty
		      {
				  if(move==0)       	        
				  {
					for(int i=0;i<4;i++)
					{
					    surroundingblock[i].checkstatus=0;
					    for(int j=0;j<16;j++)
					    {
					       if(Position(surroundingblock[i])==Position(whitepiececenter[j]))
					       {
						     surroundingblock[i].checkstatus=2;
						     break;
					       }
					       else  if(Position(surroundingblock[i])==Position(blackpiececenter[j]))
					       {
						     surroundingblock[i].checkstatus=1;
						     break;
					       }
					    }
					}
				  }
				  else if(move==1)
				  {
					for(int i=0;i<3;i++)
					{
					    surroundingblock[i].checkstatus=0;
					    for(int j=0;j<16;j++)
					    {
					       if(Position(surroundingblock[i])==Position(whitepiececenter[j]))
					       {
						     surroundingblock[i].checkstatus=2;
						     break;
					       }
					       else  if(Position(surroundingblock[i])==Position(blackpiececenter[j]))
					       {
						     surroundingblock[i].checkstatus=1;
						     break;
					       }
					    }
					}
				}
			}//end of function checkposition
		      
		      void validate()               //function to fill valid moves in an array
		      {
				  if(move==0)
				  { 
						if(surroundingblock[0].checkstatus==2)
						{
							//Position(validmoves[0])=Position(surroundingblock[0]);
							validmoves[0]=surroundingblock[0];
						}
						else
							validmoves[0].checkstatus=-1;
						if(surroundingblock[2].checkstatus==2)
						{
								//Position(validmoves[1])=Position(surroundingblock[2]);
							validmoves[1]=surroundingblock[2];
						}
						else
							validmoves[1].checkstatus=-1;
						if(surroundingblock[1].checkstatus==0)
						{           
								//Position(validmoves[2])=Position(surroundingblock[1]);
							validmoves[2]=surroundingblock[1];		                
							if(surroundingblock[3].checkstatus==0)
							{
								    //Position(validmoves[3])=Position(surroundingblock[3]);
								validmoves[3]=surroundingblock[3];
							}
							else
								validmoves[3].checkstatus=-1;		        
						}
						else
							validmoves[2].checkstatus=-1;
			  	  }
				  else if(move==1) 
				  { 
						if(surroundingblock[0].checkstatus==2)
						{
							//Position(validmoves[0])=Position(surroundingblock[0]);
							validmoves[0]=surroundingblock[0];
						}
						else
							validmoves[0].checkstatus=-1;
						if(surroundingblock[2].checkstatus==2)
						{
								//Position(validmoves[1])=Position(surroundingblock[2]);
							validmoves[1]=surroundingblock[2];
						}
						else
							validmoves[1].checkstatus=-1;
						if(surroundingblock[1].checkstatus==0)
						{           
								//Position(validmoves[2])=Position(surroundingblock[1]);
							validmoves[2]=surroundingblock[1];
						}
						else
							validmoves[2].checkstatus=-1;
				  }
		      }//end of function validate
	
		      int compare(Position c)                  //this function finds out whetehr the click made lies in the valid moves or not
		      {
				  int flag=0;
				  if(move==1)
				  {
					for(int i=0;i<4;i++)
					{	
						if(validmoves[i].checkstatus!=-1)
						{
							if(Position(c)==Position(validmoves[i]))
							{
								if(validmoves[i].checkstatus==0)
								{
									flag=1;
									break;
								}
								else if(validmoves[i].checkstatus==2)
								{
									flag=2;
									break;
								}
							}
						}
					}	
				   }
				   else if(move==1)
				   {
					for(int i=0;i<3;i++)
					{
						if(validmoves[i].checkstatus!=-1)
						{
							if(Position(c)==Position(validmoves[i]))
							{
								if(validmoves[i].checkstatus==0)
								{
									flag=1;
									break;
								}
								else if(validmoves[i].checkstatus==2)
								{
									flag=2;
									break;
								}
							}
						}
					}	
				   }
				   return flag;	
		      }//end of function compare
	      
	}bp1,bp2,bp3,bp4,bp5,bp6,bp7,bp8;   //creating 8 objects each corresponding to the individual black pawn
	
	
	
	


	//Defining  a class for white knight movement

	class wknightmove
	{
	   public:
		BitMap obj;
		int life;           
		newpos possiblemov[8]; //it tells the total possible moves for the selected white knight
		newpos validmoves[8];  // it tells the all the valid moves that a selected white knight can move acc. to the current condition
		void initialise()      //it intialises the array possiblemov
		{	
				
			possiblemov[0].SetXDistance(obj.GetXPosition()+2*2.0);
			possiblemov[0].SetYDistance(obj.GetYPosition()-1*2.0);
			possiblemov[1].SetXDistance(obj.GetXPosition()+2*2.0);
			possiblemov[1].SetYDistance(obj.GetYPosition()+1*2.0);
			possiblemov[2].SetXDistance(obj.GetXPosition()-2*2.0);
			possiblemov[2].SetYDistance(obj.GetYPosition()-1*2.0);
			possiblemov[3].SetXDistance(obj.GetXPosition()-2*2.0);
			possiblemov[3].SetYDistance(obj.GetYPosition()+1*2.0);
			possiblemov[4].SetXDistance(obj.GetXPosition()+1*2.0);
			possiblemov[4].SetYDistance(obj.GetYPosition()+2*2.0);
			possiblemov[5].SetXDistance(obj.GetXPosition()+1*2.0);
			possiblemov[5].SetYDistance(obj.GetYPosition()-2*2.0);
			possiblemov[6].SetXDistance(obj.GetXPosition()-1*2.0);
			possiblemov[6].SetYDistance(obj.GetYPosition()+2*2.0);
			possiblemov[7].SetXDistance(obj.GetXPosition()-1*2.0);
			possiblemov[7].SetYDistance(obj.GetYPosition()-2*2.0);
		}

	//possiblity of moves done
	//now we need to check if the move at any position is possible or not.

		void checkposition()            //checking if possible moves block is occupied by ally, foe or is empty
		{
	
			for(int i=0;i<8*2.0;i++)
			{
				if(possiblemov[i].GetXDistance()<2.0 || possiblemov[i].GetYDistance()<1.5 || possiblemov[i].GetXDistance()>16.0 || possiblemov[i].GetYDistance()>1.5)					
					possiblemov[i].checkstatus=-1; // the move is out of the chessboard
				else
				{
					possiblemov[i].checkstatus=0;
					for(int j=0;j<16;j++)
					{
					//checkstat=0 if empty,checkstat=1 if ally and checkstat=2 if enemy
			       			if(Position(possiblemov[i])==Position(whitepiececenter[j]))
						{
				     			possiblemov[i].checkstatus=1;
				     			break;
						}
			       			else  if(Position(possiblemov[i])==Position(blackpiececenter[j]))
				 		{
				        		possiblemov[i].checkstatus=2;
				        		break;
				 		}
			    		}	
				}
			}
		}

		void validate() // extracts the possible valid moves from possible moves and store it in valid moves array
		{
			for(int i=0,c=0;i<8;i++)
			{
				if(possiblemov[i].checkstatus==0 || possiblemov[i].checkstatus==2)
				{
					validmoves[c]=possiblemov[i];
					c++;
			  	}
			}
		}

		int compare(Position c)                  //this function finds out whetehr the click made lies in the valid moves or not
		{
			int flag=0;
		  	for(int i=0;i<8;i++)
			{	
				if(validmoves[i].checkstatus!=-1)
				{
					if(Position(c)==Position(validmoves[i]))
					{
						if(validmoves[i].checkstatus==0)
						{
							flag=1;
							break;
						}
						else if(validmoves[i].checkstatus==2)
						{
							flag=2;
							break;
						}
					}
				}
			}	
			return flag;	
		  }
	}wkn1,wkn2;         //creating two objects each corresponding to the two white knights


	class bknightmove
	{
		public:
		BitMap obj;
		int life;
		newpos possiblemov[8]; //it tells all the possible moves that a black knight can move
	 	newpos validmoves[8];  //it tells all the valid moves that a selected black knight can move acc. to the current conditions
		void initialise()      //it intialises the array possiblemov
		{				
			possiblemov[0].SetXDistance(obj.GetXPosition()+2*2.0);
			possiblemov[0].SetYDistance(obj.GetYPosition()-1*2.0);
			possiblemov[1].SetXDistance(obj.GetXPosition()+2*2.0);
			possiblemov[1].SetYDistance(obj.GetYPosition()+1*2.0);
			possiblemov[2].SetXDistance(obj.GetXPosition()-2*2.0);
			possiblemov[2].SetYDistance(obj.GetYPosition()-1*2.0);
			possiblemov[3].SetXDistance(obj.GetXPosition()-2*2.0);
			possiblemov[3].SetYDistance(obj.GetYPosition()+1*2.0);
			possiblemov[4].SetXDistance(obj.GetXPosition()+1*2.0);
			possiblemov[4].SetYDistance(obj.GetYPosition()+2*2.0);
			possiblemov[5].SetXDistance(obj.GetXPosition()+1*2.0);
			possiblemov[5].SetYDistance(obj.GetYPosition()-2*2.0);
			possiblemov[6].SetXDistance(obj.GetXPosition()-1*2.0);
			possiblemov[6].SetYDistance(obj.GetYPosition()+2*2.0);
			possiblemov[7].SetXDistance(obj.GetXPosition()-1*2.0);
			possiblemov[7].SetYDistance(obj.GetYPosition()-2*2.0);
		}
	
	
			//possiblity of moves done
			//now we need to check if the move at any position is possible or not.
		
		void checkposition()            //checking if possible moves block is occupied by ally, foe or is empty
		{
			
			for(int i=0;i<8;i++)
			{
			    	if(possiblemov[i].GetXDistance()<2.0 || possiblemov[i].GetYDistance()<1.5 || possiblemov[i].GetXDistance()>16.0 || possiblemov[i].GetYDistance()>15.5)			
					possiblemov[i].checkstatus=-1; // the move is out of the chessboard
				else
				{
					possiblemov[i].checkstatus=0;
				    	for(int j=0;j<16;j++)
				    	{
					//checkstat=0 if empty,checkstat=1 if ally and checkstat=2 if enemy
			   			if(Position(possiblemov[i])==Position(blackpiececenter[j]))
				    		{
			         			possiblemov[i].checkstatus=1;
			         			break;
				    		}
			   			else  if(Position(possiblemov[i])==Position(whitepiececenter[j]))
				     		{
				            		possiblemov[i].checkstatus=2;
				            		break;
				     		}
					}	
			    	}
			}
		}

		void validate() // extracts the possible valid moves from possible moves and store it in valid moves array 
		{
			
			for(int i=0,c=0;i<8;i++)
			{
				if(possiblemov[i].checkstatus==0 || possiblemov[i].checkstatus==2)
				{
					validmoves[c]=possiblemov[i];
					c++;
		      		}
			}
		}
		
		int compare(Position c)                  //this function finds out whetehr the click made lies in the valid moves or not
		{
			int flag=0;
		  	for(int i=0;i<8;i++)
			{	
				if(validmoves[i].checkstatus!=-1)
				{
					if(Position(c)==Position(validmoves[i]))
					{
						if(validmoves[i].checkstatus==0)
						{
							flag=1;
							break;
						}
						else if(validmoves[i].checkstatus==2)
						{
							flag=2;
							break;
						}
					}
				}
			}	
			return flag;	
		}
	}bkn1,bkn2;		//creating two objects each corresponding to the two black knights



/*
This is the code to check the valid moves of the king and store them in an array. There are 3 main functions in each class(there are 2 classes:one for white and the other for black king). One function initialises the main array, one function checks the surrounding blocks for occupancy and type of occupancy and the last function stores the valid moves of the king in another array. Castling is not included in the valid moves of the king due to the limits of time.
*/


//Class for white king's moves and valid positions.
	class wkingmove
	{
		public:
		BitMap obj;
		int life;   //If life=0, the king is dead and if life=1, the king is alive.
		int status;
		newpos surroundingblock[8]; //array which will contain the number of surrounding blocks depending on the place where the king currently is.
		newpos validmoves[8];       //array which will contain the number of valid positions where the king can move.

		void initialise()     //Member function.
		{
			if((obj.GetXPosition()==2 || obj.GetXPosition()==16) && (obj.GetYPosition()==1.5 || obj.GetYPosition()==15.5))
			//The king is at any of the corners.
			{
				status=0;  //Temporary variable for number of different directions for king to move.
			}
			else if((obj.GetXPosition()<16 && obj.GetXPosition()>2) && (obj.GetYPosition()<15.5 && obj.GetYPosition()>1.5))
			//The king is anywhere on the board except at the corners or edges.
			{
			   status=2;
			}
			else    //The king is at the edges but not at the corners.
			{
			   status=1;
			}

			
			if(status==0)    //The king is at a corner
			{
				for(int i=3;i<8;i++)
				{            //Assigning sentinel values to rest of the array elements.
					surroundingblock[i].SetXDistance(-1); surroundingblock[i].SetYDistance(-1);
				}
				if(obj.GetXPosition()==2 && obj.GetYPosition()==1.5)
				{            //Top left corner.
					surroundingblock[0].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[0].SetYDistance(obj.GetYPosition());
					surroundingblock[1].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[1].SetYDistance(obj.GetYPosition()+2);
					surroundingblock[2].SetXDistance(obj.GetXPosition()); 
					surroundingblock[2].SetYDistance(obj.GetYPosition()+2);
				}
				else if(obj.GetXPosition()==2 && obj.GetYPosition()==15.5)
				{           //Bottom left corner.
					surroundingblock[0].SetXDistance(obj.GetXPosition()); 
					surroundingblock[0].SetYDistance(obj.GetYPosition()-2);
					surroundingblock[1].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[1].SetYDistance(obj.GetYPosition()-2);
					surroundingblock[2].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[2].SetYDistance(obj.GetYPosition());
				}
				else if(obj.GetXPosition()==16 && obj.GetYPosition()==1.5)
				{           //Top right corner.
					surroundingblock[0].SetXDistance(obj.GetXPosition()); 
					surroundingblock[0].SetYDistance(obj.GetYPosition()+2);
					surroundingblock[1].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[1].SetYDistance(obj.GetYPosition()+2);
					surroundingblock[2].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[2].SetYDistance(obj.GetYPosition());
				}
				else
				{          //Bottom right corner.
					surroundingblock[0].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[0].SetYDistance(obj.GetYPosition());
					surroundingblock[1].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[1].SetYDistance(obj.GetYPosition()-2);
					surroundingblock[2].SetXDistance(obj.GetXPosition()); 
					surroundingblock[2].SetYDistance(obj.GetYPosition()-2);
				}
			}
			else if(status==2)  //The king is anywhere in the middle except at the corners or edges.
			{
				surroundingblock[0].SetXDistance(obj.GetXPosition()-2); 
				surroundingblock[0].SetYDistance(obj.GetYPosition()-2);
				surroundingblock[1].SetXDistance(obj.GetXPosition()); 
				surroundingblock[1].SetYDistance(obj.GetYPosition()-2);
				surroundingblock[2].SetXDistance(obj.GetXPosition()+2); 
				surroundingblock[2].SetYDistance(obj.GetYPosition()-2);
				surroundingblock[3].SetXDistance(obj.GetXPosition()+2); 
				surroundingblock[3].SetYDistance(obj.GetYPosition());
				surroundingblock[4].SetXDistance(obj.GetXPosition()+2); 
				surroundingblock[4].SetYDistance(obj.GetYPosition()+2);
				surroundingblock[5].SetXDistance(obj.GetXPosition()); 
				surroundingblock[5].SetYDistance(obj.GetYPosition()+2);
				surroundingblock[6].SetXDistance(obj.GetXPosition()-2); 
				surroundingblock[6].SetYDistance(obj.GetYPosition()+2);
				surroundingblock[7].SetXDistance(obj.GetXPosition()-2); 
				surroundingblock[7].SetYDistance(obj.GetYPosition());
			}
			else    //The king is at the edge.
			{
				for(int i=5;i<8;i++)
				{     //Assigning sentinel values to the rest of the array elements.
					surroundingblock[i].SetXDistance(-1); surroundingblock[i].SetYDistance(-1);
				}
				if(obj.GetYPosition()==1.5 && obj.GetXPosition()!=2 && obj.GetXPosition()!=16)
				{ 
										 /* It means the king is at the 
				                                                     top edge and also it is not
										     at the corners.*/
					surroundingblock[0].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[0].SetYDistance(obj.GetYPosition());
					surroundingblock[1].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[1].SetYDistance(obj.GetYPosition()+2);
					surroundingblock[2].SetXDistance(obj.GetXPosition()); 
					surroundingblock[2].SetYDistance(obj.GetYPosition()+2);
					surroundingblock[3].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[3].SetYDistance(obj.GetYPosition()+2);
					surroundingblock[4].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[4].SetYDistance(obj.GetYPosition());
				}
				else if(obj.GetYPosition()==15.5 && obj.GetXPosition()!=2 && obj.GetXPosition()!=16)
				{ 
										  /* It means the king is at
										          the bottom
						                                          edge and also it is not
										          at the corners.*/
					surroundingblock[0].SetXDistance(obj.GetXPosition()); 
					surroundingblock[0].SetYDistance(obj.GetYPosition()-2);
					surroundingblock[1].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[1].SetYDistance(obj.GetYPosition()-2);
					surroundingblock[2].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[2].SetYDistance(obj.GetYPosition());
					surroundingblock[3].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[3].SetYDistance(obj.GetYPosition()-2);
					surroundingblock[4].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[4].SetYDistance(obj.GetYPosition());
				}
				else if(obj.GetXPosition()==16 && obj.GetYPosition()!=1.5 && obj.GetYPosition()!=15.5)
				{ 
										 /* It means the king is at
										         the right end
						                                         edge and also it is not
										         at the corners.*/
					surroundingblock[0].SetXDistance(obj.GetXPosition()); 
					surroundingblock[0].SetYDistance(obj.GetYPosition()+2);
					surroundingblock[1].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[1].SetYDistance(obj.GetYPosition()+2);
					surroundingblock[2].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[2].SetYDistance(obj.GetYPosition());
					surroundingblock[3].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[3].SetYDistance(obj.GetYPosition()-2);
					surroundingblock[4].SetXDistance(obj.GetXPosition()); 
					surroundingblock[4].SetYDistance(obj.GetYPosition()-2);
				}
				else if(obj.GetXPosition()==1 && obj.GetYPosition()!=1.5 && obj.GetYPosition()!=15.5)
				{ 
										  /* It means the king is at
										      the left end
						                                      edge and also it is not
										      at the corners.*/
					surroundingblock[0].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[0].SetYDistance(obj.GetYPosition());
					surroundingblock[1].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[1].SetYDistance(obj.GetYPosition()+2);
					surroundingblock[2].SetXDistance(obj.GetXPosition()); 
					surroundingblock[2].SetYDistance(obj.GetYPosition()+2);
					surroundingblock[3].SetXDistance(obj.GetXPosition()); 
					surroundingblock[3].SetYDistance(obj.GetYPosition()-2);
					surroundingblock[4].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[4].SetYDistance(obj.GetYPosition()-2);
				}
			}
		}


		void checkposition()           /*function to find whether surrounding pieces are occupied by friendlies, enemies or are empty.*/
		{   
			if(status==0)    //The king is at any of the corners.
			{
				for(int i=0;i<3;i++)
				{
					surroundingblock[i].checkstatus=0;
					for(int j=0;j<16;j++)
					{
							if(Position(surroundingblock[i])==Position(whitepiececenter[j]))
						{
							surroundingblock[i].checkstatus=1;
							break;
						}
						else  if(Position(surroundingblock[i])==Position(blackpiececenter[j]))
						{
							surroundingblock[i].checkstatus=2;
							break;
						}
					}
				}
			}
			else if(status==1)    //The king is at the edges but not at the corners.
			{
				for(int i=0;i<5;i++)
				{
					surroundingblock[i].checkstatus=0;
					for(int j=0;j<16;j++)
					{
							if(Position(surroundingblock[i])==Position(whitepiececenter[j]))
						{
							surroundingblock[i].checkstatus=1;
							break;
						}
						else  if(Position(surroundingblock[i])==Position(blackpiececenter[j]))
						{
							surroundingblock[i].checkstatus=2;
							break;
						}
					}
				}
			}
			else     //The king is at anywhere in the middle except at the edges or the corners.
			{
				for(int i=0;i<8;i++)
				{
					surroundingblock[i].checkstatus=0;
					for(int j=0;j<16;j++)
					{
							if(Position(surroundingblock[i])==Position(whitepiececenter[j]))
						{
							surroundingblock[i].checkstatus=1;
							break;
						}
						else  if(Position(surroundingblock[i])==Position(blackpiececenter[j]))
						{
							surroundingblock[i].checkstatus=2;
							break;
						}
					}
				}
			}
		}


		void validate()       //Function to store the valid moves of the king.
		{
			if(status==0)  //The king is at the corners.
			{
				for(int i=0;i<3;i++)
				{
					if(surroundingblock[i].checkstatus==0 || surroundingblock[i].checkstatus==2)
					{
						//Position(validmoves[i])=Position(surroundingblock[i]);
						validmoves[i]=surroundingblock[i];
					}
					else validmoves[i].checkstatus=-1;
				}
			}
			else if(status==1)  //The king is at the edges but not at the corners.
			{
				for(int i=0;i<5;i++)
				{
					if(surroundingblock[0].checkstatus==0 || surroundingblock[0].checkstatus==2)
					{
						//Position(validmoves[0])=Position(surroundingblock[0]);
						validmoves[i]=surroundingblock[i];
					}
					else validmoves[i].checkstatus=-1;
				}
			}
			else     //The king is anywhere in the middle except at the edges or corners.
			{
				for(int i=0;i<8;i++)
				{
					if(surroundingblock[0].checkstatus==0 || surroundingblock[0].checkstatus==2)
					{
						//Position(validmoves[0])=Position(surroundingblock[0]);
						validmoves[i]=surroundingblock[i];
					}
					else validmoves[i].checkstatus=-1;
				}
			}
		}

		int compare(Position c)     //This function finds whether the click made lies in the valid moves or not.
		{
			int flag=0;
			if(status==0)
			{
				for(int i=0;i<3;i++)
				{
					if(validmoves[i].checkstatus!=-1)
					{
						if(Position(c)==Position(validmoves[i]))
						{
			                		if(validmoves[i].checkstatus==0)
			                		{
			                    			flag=1;
			                    			break;
			                		}
			                		else if(validmoves[i].checkstatus==2)
			                		{
			                     			flag=2;
			                     			break;
			                		}
			            		}
			        	}
			    	}
			}
			else if(status==1)
			{
			     for(int i=0;i<5;i++)
			     {
			           if(validmoves[i].checkstatus!=-1)
				   {
				   	if(Position(c)==Position(validmoves[i]))
					{
						if(validmoves[i].checkstatus==0)
					        {
					              flag=1;
					              break;
					        }
					        else if(validmoves[i].checkstatus==2)
					        {
					              flag=2;
					              break;
					        }
					 }
			           }
			     }
			}  
			else
			{
			    for(int i=0;i<8;i++)
			    {
			            if(validmoves[i].checkstatus!=-1)
				    {
				    	if(Position(c)==Position(validmoves[i]))
					{
			     		       	if(validmoves[i].checkstatus==0)
			                	{
			                 		flag=1;
			                 		break;
			                	}
			                	else if(validmoves[i].checkstatus==2)
			                	{
			                     		flag=2;
			                		break;
			                        }
			        	}
			    	    }
			    }
			}
		        return flag;
		 }
	}wk;                          //creating object for the white king


	//Class for black king's moves and valid positions.
	class bkingmove
	{
		public:
		BitMap obj;
		int life;   //If life=0, the king is dead and if life=1, the king is alive.
		int status;
		newpos surroundingblock[8]; /*array which will contain the number of surrounding blocks depending on the place where the king currently is.*/
		newpos validmoves[8];       //array which will contain the number of valid positions where the king can move.

		void initialise()     //Member function.
		{
			if(status==0)    //The king is at a corner
			{
				for(int i=3;i<8;i++)
				{            //Assigning sentinel values to rest of the array elements.
					surroundingblock[i].SetXDistance(-1); surroundingblock[i].SetYDistance(-1);
				}
				if(obj.GetXPosition()==2 && obj.GetYPosition()==1.5)
				{            //Top left corner.
					surroundingblock[0].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[0].SetYDistance(obj.GetYPosition());
					surroundingblock[1].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[1].SetYDistance(obj.GetYPosition()+2);
					surroundingblock[2].SetXDistance(obj.GetXPosition()); 
					surroundingblock[2].SetYDistance(obj.GetYPosition()+2);
				}
				else if(obj.GetXPosition()==2 && obj.GetYPosition()==15.5)
				{           //Bottom left corner.
					surroundingblock[0].SetXDistance(obj.GetXPosition()); 
					surroundingblock[0].SetYDistance(obj.GetYPosition()-2);
					surroundingblock[1].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[1].SetYDistance(obj.GetYPosition()-2);
					surroundingblock[2].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[2].SetYDistance(obj.GetYPosition());
				}
				else if(obj.GetXPosition()==16 && obj.GetYPosition()==1.5)
				{           //Top right corner.
					surroundingblock[0].SetXDistance(obj.GetXPosition()); 
					surroundingblock[0].SetYDistance(obj.GetYPosition()+2);
					surroundingblock[1].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[1].SetYDistance(obj.GetYPosition()+2);
					surroundingblock[2].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[2].SetYDistance(obj.GetYPosition());
				}
				else
				{          //Bottom right corner.
					surroundingblock[0].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[0].SetYDistance(obj.GetYPosition());
					surroundingblock[1].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[1].SetYDistance(obj.GetYPosition()-2);
					surroundingblock[2].SetXDistance(obj.GetXPosition()); 
					surroundingblock[2].SetYDistance(obj.GetYPosition()-2);
				}
			}
			else if(status==2)  //The king is anywhere in the middle except at the corners or edges.
			{
				surroundingblock[0].SetXDistance(obj.GetXPosition()-2); 
				surroundingblock[0].SetYDistance(obj.GetYPosition()-2);
				surroundingblock[1].SetXDistance(obj.GetXPosition()); 
				surroundingblock[1].SetYDistance(obj.GetYPosition()-2);
				surroundingblock[2].SetXDistance(obj.GetXPosition()+2); 
				surroundingblock[2].SetYDistance(obj.GetYPosition()-2);
				surroundingblock[3].SetXDistance(obj.GetXPosition()+2); 
				surroundingblock[3].SetYDistance(obj.GetYPosition());
				surroundingblock[4].SetXDistance(obj.GetXPosition()+2); 
				surroundingblock[4].SetYDistance(obj.GetYPosition()+2);
				surroundingblock[5].SetXDistance(obj.GetXPosition()); 
				surroundingblock[5].SetYDistance(obj.GetYPosition()+2);
				surroundingblock[6].SetXDistance(obj.GetXPosition()-2); 
				surroundingblock[6].SetYDistance(obj.GetYPosition()+2);
				surroundingblock[7].SetXDistance(obj.GetXPosition()-2); 
				surroundingblock[7].SetYDistance(obj.GetYPosition());
			}
			else    //The king is at the edge.
			{
				for(int i=5;i<8;i++)
				{     //Assigning sentinel values to the rest of the array elements.
					surroundingblock[i].SetXDistance(-1); surroundingblock[i].SetYDistance(-1);
				}
				if(obj.GetYPosition()==1.5 && obj.GetXPosition()!=2 && obj.GetXPosition()!=16)
				{ 
										 /* It means the king is at the 
				                                                     top edge and also it is not
										     at the corners.*/
					surroundingblock[0].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[0].SetYDistance(obj.GetYPosition());
					surroundingblock[1].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[1].SetYDistance(obj.GetYPosition()+2);
					surroundingblock[2].SetXDistance(obj.GetXPosition()); 
					surroundingblock[2].SetYDistance(obj.GetYPosition()+2);
					surroundingblock[3].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[3].SetYDistance(obj.GetYPosition()+2);
					surroundingblock[4].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[4].SetYDistance(obj.GetYPosition());
				}
				else if(obj.GetYPosition()==15.5 && obj.GetXPosition()!=2 && obj.GetXPosition()!=16)
				{ 
										  /* It means the king is at
										          the bottom
						                                          edge and also it is not
										          at the corners.*/
					surroundingblock[0].SetXDistance(obj.GetXPosition()); 
					surroundingblock[0].SetYDistance(obj.GetYPosition()-2);
					surroundingblock[1].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[1].SetYDistance(obj.GetYPosition()-2);
					surroundingblock[2].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[2].SetYDistance(obj.GetYPosition());
					surroundingblock[3].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[3].SetYDistance(obj.GetYPosition()-2);
					surroundingblock[4].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[4].SetYDistance(obj.GetYPosition());
				}
				else if(obj.GetXPosition()==16 && obj.GetYPosition()!=1.5 && obj.GetYPosition()!=15.5)
				{ 
										 /* It means the king is at
										         the right end
						                                         edge and also it is not
										         at the corners.*/
					surroundingblock[0].SetXDistance(obj.GetXPosition()); 
					surroundingblock[0].SetYDistance(obj.GetYPosition()+2);
					surroundingblock[1].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[1].SetYDistance(obj.GetYPosition()+2);
					surroundingblock[2].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[2].SetYDistance(obj.GetYPosition());
					surroundingblock[3].SetXDistance(obj.GetXPosition()-2); 
					surroundingblock[3].SetYDistance(obj.GetYPosition()-2);
					surroundingblock[4].SetXDistance(obj.GetXPosition()); 
					surroundingblock[4].SetYDistance(obj.GetYPosition()-2);
				}
				else if(obj.GetXPosition()==1 && obj.GetYPosition()!=1.5 && obj.GetYPosition()!=15.5)
				{ 
										  /* It means the king is at
										      the left end
						                                      edge and also it is not
										      at the corners.*/
					surroundingblock[0].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[0].SetYDistance(obj.GetYPosition());
					surroundingblock[1].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[1].SetYDistance(obj.GetYPosition()+2);
					surroundingblock[2].SetXDistance(obj.GetXPosition()); 
					surroundingblock[2].SetYDistance(obj.GetYPosition()+2);
					surroundingblock[3].SetXDistance(obj.GetXPosition()); 
					surroundingblock[3].SetYDistance(obj.GetYPosition()-2);
					surroundingblock[4].SetXDistance(obj.GetXPosition()+2); 
					surroundingblock[4].SetYDistance(obj.GetYPosition()-2);
				}
			}
		}


		void checkposition()           /*function to find whether surrounding pieces are occupied by friendlies, enemies or are empty.*/
		{   
			if(status==0)    //The king is at any of the corners.
			{
				for(int i=0;i<3;i++)
				{
					surroundingblock[i].checkstatus=0;
					for(int j=0;j<16;j++)
					{
						if(Position(surroundingblock[i])==Position(blackpiececenter[j]))
						{
							surroundingblock[i].checkstatus=1;
							break;
						}
						else  if(Position(surroundingblock[i])==Position(whitepiececenter[j]))
						{
							surroundingblock[i].checkstatus=2;
							break;
						}
					}
				}
			}
			else if(status==1)    //The king is at the edges but not at the corners.
			{
				for(int i=0;i<5;i++)
				{
					surroundingblock[i].checkstatus=0;
					for(int j=0;j<16;j++)
					{
						if(Position(surroundingblock[i])==Position(blackpiececenter[j]))
						{
							surroundingblock[i].checkstatus=1;
							break;
						}
						else  if(Position(surroundingblock[i])==Position(whitepiececenter[j]))
						{
							surroundingblock[i].checkstatus=2;
							break;
						}
					}
				}
			}
			else     //The king is at anywhere in the middle except at the edges or the corners.
			{
				for(int i=0;i<8;i++)
				{
					surroundingblock[i].checkstatus=0;
					for(int j=0;j<16;j++)
					{
						if(Position(surroundingblock[i])==Position(blackpiececenter[j]))
						{
							surroundingblock[i].checkstatus=1;
							break;
						}
						else  if(Position(surroundingblock[i])==Position(whitepiececenter[j]))
						{
							surroundingblock[i].checkstatus=2;
							break;
						}
					}
				}
			}
		}


		void validate()       //Function to store the valid moves of the king.
		{
			if(status==0)  //The king is at the corners.
			{
				for(int i=0;i<3;i++)
				{
					if(surroundingblock[i].checkstatus==0 || surroundingblock[i].checkstatus==2)
					{
						//Position(validmoves[i])=Position(surroundingblock[i]);
						validmoves[i]=surroundingblock[i];
					}
					else validmoves[i].checkstatus=-1;
				}
			}
			else if(status==1)  //The king is at the edges but not at the corners.
			{
				for(int i=0;i<5;i++)
				{
					if(surroundingblock[0].checkstatus==0 || surroundingblock[0].checkstatus==2)
					{
						//Position(validmoves[0])=Position(surroundingblock[0]);
						validmoves[i]=surroundingblock[i];
					}
					else validmoves[i].checkstatus=-1;
				}
			}
			else     //The king is anywhere in the middle except at the edges or corners.
			{
				for(int i=0;i<8;i++)
				{
					if(surroundingblock[0].checkstatus==0 || surroundingblock[0].checkstatus==2)
					{
						//Position(validmoves[0])=Position(surroundingblock[0]);
						validmoves[i]=surroundingblock[i];
					}
					else validmoves[i].checkstatus=-1;
				}
			}
		}

		int compare(Position c)     //This function finds whether the click made lies in the valid moves or not.
		{
			int flag=0;
			if(status==0)
			{
				for(int i=0;i<3;i++)
				{
					if(validmoves[i].checkstatus!=-1)
					{
						if(Position(c)==Position(validmoves[i]))
						{
			                		if(validmoves[i].checkstatus==0)
			                		{
			                    			flag=1;
			                    			break;
			                		}
			                		else if(validmoves[i].checkstatus==2)
			                		{
			                     			flag=2;
			                     			break;
			                		}
			            		}
			        	}
			    	}
			}
			else if(status==1)
			{
			     for(int i=0;i<5;i++)
			     {
			     		if(validmoves[i].checkstatus!=-1)
					{
						if(Position(c)==Position(validmoves[i]))
						{
			                		if(validmoves[i].checkstatus==0)
			                		{
			                  			flag=1;
			                    			break;
			                		}
			                		else if(validmoves[i].checkstatus==2)
			                		{
			                     			flag=2;
			                     			break;
			                		}
			            		}
			          	}
			    }
			}  
			else
			{
			    for(int i=0;i<8;i++)
			    {
			            if(validmoves[i].checkstatus!=-1)
				    {
					if(Position(c)==Position(validmoves[i]))
					{
			                	if(validmoves[i].checkstatus==0)
			                	{
			                    		flag=1;
			                    		break;
			                	}
			                	else if(validmoves[i].checkstatus==2)
			                	{
			                     		flag=2;
			                     		break;
			                	}
			            	}
			           }
			    }
			}
			return flag;
		 }
	}bk;               //creating object for black king




	class wrookmove
	{
		public:
	  	//data members
	  	BitMap obj;
	  	int life; // life=0 if dead and life=1 if alive
	  	newpos surroundingblock1[7];
	  	newpos surroundingblock2[7];
	  	newpos surroundingblock3[7];
	  	newpos surroundingblock4[7];
	  	newpos validmoves[14];
	  
	  	//member functions

		// Entering positions of surrounding blocks
	  	void initialise()
	  	{      
	      		for(int i=obj.GetXPosition()+2.0,c=0; i<=2.0+2.0*7; i+=2.0,c++)       
	      		{
				surroundingblock1[c].SetXDistance(i);
		    		surroundingblock1[c].SetYDistance(obj.GetYPosition());
	      		}
	  
	      		for(int i=obj.GetXPosition()-2.0,c=0; i>=2.0; i-=2.0,c++)
	      		{
				surroundingblock2[c].SetXDistance(i);
		    		surroundingblock2[c].SetYDistance(obj.GetYPosition());
	      		}
	 
	      		for(int i=obj.GetYPosition()-2.0,c=0; i>=1.5; i-=2.0,c++)
	      		{
	       			surroundingblock3[c].SetYDistance(i);
	   	   		surroundingblock3[c].SetXDistance(obj.GetXPosition());
	      		}
	   		for(int i=obj.GetYPosition()+2.0,c=0; i<=1.5+2.0*7; i+=2.0,c++)
	      		{
				surroundingblock4[c].SetYDistance(i);
		    		surroundingblock4[c].SetXDistance(obj.GetXPosition());
	      		} 
	  	}

		// Getting value of checkstatus for each block 
	  	void checkposition()
	  	{
	    		for(int i=0; i<(((2.0+2.0*7)-obj.GetXPosition())/2.0); i++)
	    		{       
				if(surroundingblock1[i].GetXDistance()<2.0 || surroundingblock1[i].GetYDistance()<1.5 || surroundingblock1[i].GetXDistance()>16.0 || surroundingblock1[i].GetYDistance()>15.5)			
		    			surroundingblock1[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{
			    		surroundingblock1[i].checkstatus=0;
		    			for(int j=0;j<16;j++)
			    		{ 
				    		if (Position(surroundingblock1[i])==Position(whitepiececenter[j]))
				    		{
				      			surroundingblock1[i].checkstatus=1;
				      			break;
				    		}
			     		}
			     		for(int j=0;j<16;j++)
			     		{ 
				    		if (Position(surroundingblock1[i])==Position(blackpiececenter[j]))
				    		{
					      		surroundingblock1[i].checkstatus=2;
					       		break;
					    	}
				    	}
		       		}
		     	}

		    	for(int i=0; i<(obj.GetXPosition()-2.0)/2.0; i++)
		    	{
				if(surroundingblock2[i].GetXDistance()<2.0 || surroundingblock2[i].GetYDistance()<1.5 || surroundingblock2[i].GetXDistance()>16.0 || surroundingblock2[i].GetYDistance()>15.5)			
			    	surroundingblock2[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{
			       		surroundingblock2[i].checkstatus=0;
			       		for(int j=0;j<16;j++)
			       		{ 
					   		if (Position(surroundingblock2[i])==Position(whitepiececenter[j]))
					   		{
					      		surroundingblock2[i].checkstatus=1;
					      		break;
					   		}
			       		}
			       		for(int j=0;j<16;j++)
			       		{ 
					   		if (Position(surroundingblock2[i])==Position(blackpiececenter[j]))
					   		{
					     		surroundingblock2[i].checkstatus=2;
					     		break;
					   		}
			       		}
				} 
		    	}

		    	for(int i=0; i<(((1.5+7*2.0)-obj.GetYPosition())/2.0);i++)
		    	{
				if(surroundingblock4[i].GetXDistance()<2.0 || surroundingblock4[i].GetYDistance()<1.5 || surroundingblock4[i].GetXDistance()>16.0 || surroundingblock4[i].GetYDistance()>15.5)			
			    	surroundingblock4[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{
				    	surroundingblock4[i].checkstatus=0;
				    	for(int j=0;j<16;j++)
				   		 { 
					   		 if (Position(surroundingblock4[i])==Position(whitepiececenter[j]))
					   		 {
					      		surroundingblock4[i].checkstatus=1;
					      		break;
					    	}
		   	        	}
				    	for(int j=0;j<16;j++)
				    	{ 
					    	if (Position(surroundingblock4[i])==Position(blackpiececenter[j]))
					    	{
					       		surroundingblock4[i].checkstatus=2;
					       		break;
					    	}
				    	}
		      		}
		    	}
	    
			for(int i=0; i<(obj.GetYPosition()-1.5)/2.0; i++)
			{
				if(surroundingblock3[i].GetXDistance()<2.0 || surroundingblock3[i].GetYDistance()<1.5 || surroundingblock3[i].GetXDistance()>16.0 || surroundingblock3[i].GetYDistance()>15.5)			
					surroundingblock3[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{
				    	surroundingblock3[i].checkstatus=0;
				       	for(int j=0;j<16;j++)
				       	{ 
					   	    if (Position(surroundingblock3[i])==Position(whitepiececenter[j]))
					   	    {
				    	        surroundingblock3[i].checkstatus=1;
				    	 	    break;
					  	    }
				       	}
				      	for(int j=0;j<16;j++)
				      	{ 
						   if (Position(surroundingblock3[i])==Position(blackpiececenter[j]))
						   {
							    surroundingblock3[i].checkstatus=2;
							    break;
						   }
				      	}
		    		}
	     		}
		}

		// Getting all valid moves
		void validate()
		{	    
			int c=0;
			for(int i=0; i<((2.0+2.0*7)-obj.GetXPosition())/2.0; i++)
			{
				if (surroundingblock1[i].checkstatus==0)
				{
					validmoves[c]= surroundingblock1[i];
					c++;
				}
				else if (surroundingblock1[i].checkstatus==2)
				{
					validmoves[c]= surroundingblock1[i];
					c++;
					break;
			      	}
			      	else
			      	{
					break;
			      	}
		    	}
			for(int i=0; i<(obj.GetXPosition()-2.0)/2.0; i++)
			{
				if (surroundingblock2[i].checkstatus==0)
				{
					validmoves[c]= surroundingblock2[i];
					c++;
				}
				else if (surroundingblock2[i].checkstatus==2)
				{
					validmoves[c]= surroundingblock2[i];
					c++;
					break;
				}
				else
				{
					break;
				}
			}
			for(int i=0; i<(obj.GetYPosition()-1.5)/2.0; i++)
			{
				if (surroundingblock3[i].checkstatus==0)
				{
					validmoves[c]= surroundingblock3[i];
					c++;
				}
				else if (surroundingblock3[i].checkstatus==2)
				{
					validmoves[c]= surroundingblock3[i];
					c++;			
					break;
				}
				else
				{
					break;
				}
			}
			for(int i=0; i<(((1.5+7*2.0)-obj.GetYPosition())/2.0);i++)
			{
				if (surroundingblock4[i].checkstatus==0)
				{
					validmoves[c]= surroundingblock4[i];
					c++;
			      	}
			      	else if (surroundingblock4[i].checkstatus==2)
			      	{
					validmoves[c]= surroundingblock4[i];
					c++;
					break;
			      	}
			      	else
			      	{
					break;
			      	}
		    	}
		}	

		int compare(Position c)                  //this function finds out whetehr the click made lies in the valid moves or not
		{
		  	int flag=0;
		  	for(int i=0;i<14;i++)
			{	
				if(validmoves[i].checkstatus!=-1)
				{
					if(Position(c)==Position(validmoves[i]))
					{
						if(validmoves[i].checkstatus==0)
						{
							flag=1;
							break;
						}
						else if(validmoves[i].checkstatus==2)
						{
							flag=2;
							break;
						}
					}
				}
			}	
			return flag;	
		}
	}wr1,wr2;                       //creating two objects for white rooks



	// Similarly for black rook
	class brookmove
	{
		public:
		//data members
		BitMap obj;
		int life; // life=0 if dead and life=1 if alive
		newpos surroundingblock1[7];
		newpos surroundingblock2[7];
		newpos surroundingblock3[7];
		newpos surroundingblock4[7];
		newpos validmoves[14];

		//member functions

		// Entering positions of surrounding blocks
		void initialise()
		{
			for(int i=obj.GetXPosition()+2.0,c=0; i<=2.0+2.0*7; i+=2.0,c++)
			{
			 surroundingblock1[c].SetXDistance(i);
			     surroundingblock1[c].SetYDistance(obj.GetYPosition());
			}

			for(int i=obj.GetXPosition()-2.0,c=0; i>=2.0; i-=2.0,c++)
			{
			surroundingblock2[c].SetXDistance(i);
			   surroundingblock2[c].SetYDistance(obj.GetYPosition());
			}

			for(int i=obj.GetYPosition()-2.0,c=0; i>=1.5; i-=2.0,c++)
			{
			surroundingblock3[c].SetYDistance(i);
			    surroundingblock3[c].SetXDistance(obj.GetXPosition());
			}

			for(int i=obj.GetYPosition()+2.0,c=0; i<=1.5+2.0*7; i+=2.0,c++)
			{
			surroundingblock4[c].SetYDistance(i);
			   surroundingblock4[c].SetXDistance(obj.GetXPosition());
			} 
		}

		// Getting value of checkstatus for each block 
		void checkposition()
		{
			for(int i=0; i<(((2.0+2.0*7)-obj.GetXPosition())/2.0); i++)
			{
			    if(surroundingblock1[i].GetXDistance()<2.0 || surroundingblock1[i].GetYDistance()<1.5 || surroundingblock1[i].GetXDistance()>16.0 || surroundingblock1[i].GetYDistance()>15.5)			
			    	surroundingblock1[i].checkstatus=-1; // the move is out of the chessboard			
			    else
			    {
				surroundingblock1[i].checkstatus=0;
				for(int j=0;j<16;j++)
				{ 
					if (Position(surroundingblock1[i])==Position(whitepiececenter[j]))
					{
						surroundingblock1[i].checkstatus=2;
						break;
					}
				 }

				 for(int j=0;j<16;j++)
				 { 
					if (Position(surroundingblock1[i])==Position(blackpiececenter[j]))
					{
						surroundingblock1[i].checkstatus=1;
						break;
					}
				  }
			      }
			 }

			for(int i=0; i<(obj.GetXPosition()-2.0)/2.0; i++)
			{
			    if(surroundingblock2[i].GetXDistance()<2.0 || surroundingblock2[i].GetYDistance()<1.5 || surroundingblock2[i].GetXDistance()>16.0 || surroundingblock2[i].GetYDistance()>15.5)			
			    	surroundingblock2[i].checkstatus=-1; // the move is out of the chessboard			
			    else
			    {
				surroundingblock2[i].checkstatus=0;
				for(int j=0;j<16;j++)
				{ 
				  if (Position(surroundingblock2[i])==Position(whitepiececenter[j]))
				   {
				      surroundingblock2[i].checkstatus=2;
				      break;
				   }
				}
				for(int j=0;j<16;j++)
				{ 
				   if (Position(surroundingblock2[i])==Position(blackpiececenter[j]))
				   {
				     surroundingblock2[i].checkstatus=1;
				     break;
				   }
				}
			    }
			}

			  for(int i=0; i<(((1.5+7*2.0)-obj.GetYPosition())/2.0);i++)
			  {
			    if(surroundingblock4[i].GetXDistance()<2.0 || surroundingblock4[i].GetYDistance()<1.5 || surroundingblock4[i].GetXDistance()>16.0 || surroundingblock4[i].GetYDistance()>15.5)			
			       surroundingblock4[i].checkstatus=-1; // the move is out of the chessboard			
			    else
			    {
				surroundingblock4[i].checkstatus=0;
				for(int j=0;j<16;j++)
				{ 
				    if (Position(surroundingblock4[i])==Position(whitepiececenter[j]))
				    {
				      surroundingblock4[i].checkstatus=2;
				      break;
				    }
				 }

				 for(int j=0;j<16;j++)
				 { 
				    if (Position(surroundingblock4[i])==Position(blackpiececenter[j]))
				    {
				       surroundingblock4[i].checkstatus=1;
				       break;
				    }
				  }
			      }
			 }

			for(int i=0; i<(obj.GetYPosition()-1.5)/2.0; i++)
			{
			    if(surroundingblock3[i].GetXDistance()<2.0 || surroundingblock3[i].GetYDistance()<1.5 || surroundingblock3[i].GetXDistance()>16.0 || surroundingblock3[i].GetYDistance()>15.5)			
				   surroundingblock3[i].checkstatus=-1; // the move is out of the chessboard			
			    else
			    {
				   surroundingblock3[i].checkstatus=0;
				   for(int j=0;j<16;j++)
				   { 
					   if (Position(surroundingblock3[i])==Position(whitepiececenter[j]))
					   {
						  surroundingblock3[i].checkstatus=2;
						  break;
					   }
				   }

				  for(int j=0;j<16;j++)
				  { 
						if (Position(surroundingblock4[i])==Position(blackpiececenter[j]))
					   {
						 surroundingblock3[i].checkstatus=1;
						 break;
					   }
				  }
			  	}
			}
		}

		// Getting all valid moves
		void validate()
		{
			int c=0;
			for(int i=0; i<(((2.0+2.0*7)-obj.GetXPosition())/2.0); i++)
			{
				  if (surroundingblock1[i].checkstatus==0)
				  {
					validmoves[c]=surroundingblock1[i];
					c++;
				  }

				  else if (surroundingblock1[i].checkstatus==2)
				  {
					validmoves[c]=surroundingblock1[i];
					c++;
					break;
				  }
				  else
				  {
					break;
				  }
			}

			for(int i=0; i<(obj.GetXPosition()-2.0)/2.0; i++)
			{
				  if (surroundingblock2[i].checkstatus==0)
				  {
					validmoves[c]=surroundingblock2[i];
					c++;
				  }

				  else if (surroundingblock2[i].checkstatus==2)
				  {
					validmoves[c]=surroundingblock2[i];
					c++;
					break;
				  }

				  else
				  {
					break;
				  }
			}

			for(int i=0; i<(obj.GetYPosition()-1.5)/2.0; i++)
			{
				  if (surroundingblock3[i].checkstatus==0)
				  {
					validmoves[c]=surroundingblock3[i];
					c++;
				  }

				  else if (surroundingblock3[i].checkstatus==2)
				  {
					validmoves[c]=surroundingblock3[i];
					c++;
					break;
				  }

				  else
				  {
					break;
				  }
			}

			for(int i=0; i<(((1.5+7*2.0)-obj.GetYPosition())/2.0);i++)
			{
				  if (surroundingblock4[i].checkstatus==0)
				  {
					validmoves[c]=surroundingblock4[i];
					c++;
				  }

				  else if (surroundingblock4[i].checkstatus==2)
				  {
					validmoves[c]=surroundingblock4[i];
					c++;
					break;
				  }

				  else
				  {
					break;
				  }
			}

		}

		int compare(Position c)                  //this function finds out whetehr the click made lies in the valid moves or not
		{
		  	int flag=0;
		  	for(int i=0;i<14;i++)
			{	
				if(validmoves[i].checkstatus!=-1)
				{
					if(Position(c)==Position(validmoves[i]))
					{
						if(validmoves[i].checkstatus==0)
						{
							flag=1;
							break;
						}
						else if(validmoves[i].checkstatus==2)
						{
							flag=2;
							break;
						}
					}
				}
			}	
		   	return flag;	
		}
	}br1,br2;              //creating two objects for black rooks


	//Class for white queen's moves and valid positions.
	class wqueenmove
	{
		public:
		BitMap obj;
		int life;  //If life=0, queen is dead else if life=1, queen is alive.
		newpos surroundingblock1[7];
		newpos surroundingblock2[7];
		newpos surroundingblock3[7];
		newpos surroundingblock4[7];
		newpos surroundingblock5[7];
		newpos surroundingblock6[7];
		newpos surroundingblock7[7];
		newpos surroundingblock8[7];
		//The above arrays will store the number of surrounding blocks depending on the current position of the queen.
		newpos validmoves[28];
	
		//The above array will contain the valid positions where the queen can move.

		void initialise()       //Member function.
		{
			for(int i=obj.GetXPosition()+2.0,c=0; i<=2.0+2.0*7; i+=2.0,c++)       
		 	{
		        	surroundingblock3[c].SetXDistance(i);
			     	surroundingblock3[c].SetYDistance(obj.GetYPosition());
		 	}
			for(int i=obj.GetXPosition()-2.0,c=0; i>=2.0; i-=2.0,c++)
			{
		         	surroundingblock7[c].SetXDistance(i);
			     	surroundingblock7[c].SetYDistance(obj.GetYPosition());
		 	}
	 		for(int i=obj.GetYPosition()-2.0,c=0; i>=1.5; i-=2.0,c++)
		 	{
				 surroundingblock1[c].SetYDistance(i);
				 surroundingblock1[c].SetXDistance(obj.GetXPosition());
		 	}
	   		for(int i=obj.GetYPosition()+2.0,c=0; i<=1.5+2.0*7; i+=2.0,c++)
		 	{
		         	surroundingblock5[c].SetYDistance(i);
			     	surroundingblock5[c].SetXDistance(obj.GetXPosition());
		 	}
			for(int i=obj.GetXPosition()+2.0,j=obj.GetYPosition()+2.0,c=0; i<=2.0+2.0*7,j<=1.5+7*2.0; i+=2.0,j+=2.0,c++)
			{
				surroundingblock4[c].SetXDistance(i);
				surroundingblock4[c].SetYDistance(j);
			}
			for(int i=obj.GetXPosition()-2.0,j=obj.GetYPosition()-2.0,c=0; i>=2.0,j>=1.5; i-=2.0,j-=2.0,c++)
			{
				surroundingblock8[c].SetXDistance(i);
				surroundingblock8[c].SetYDistance(j);
			}
			for(int i=obj.GetXPosition()+2.0,j=obj.GetYPosition()-2.0,c=0;i<=2.0+2.0*7 ,j>=1.5; i+=2.0,j-=2.0,c++)
			{
				surroundingblock2[c].SetXDistance(i);
				surroundingblock2[c].SetYDistance(j);
			}
			for(int i=obj.GetXPosition()-2.0,j=obj.GetYPosition()+2.0,c=0; i>=2.0,j<=1.5+2.0*7; i-=2.0,j+=2.0,c++)
			{
				surroundingblock6[c].SetXDistance(i);
				surroundingblock6[c].SetYDistance(j);
			} 
	   	}
	      
	 	// Getting value of checkstatus for each block 
	  	void checkposition()
	  	{
	       		for(int i=0; i<(((2.0+2.0*7)-obj.GetXPosition())/2.0); i++)
	       		{
		       		if(surroundingblock3[i].GetXDistance()<2.0 || surroundingblock3[i].GetYDistance()<1.5 || surroundingblock3[i].GetXDistance()>16.0 || surroundingblock3[i].GetYDistance()>15.5)			
		            		surroundingblock3[i].checkstatus=-1; // the move is out of the chessboard			
		       		else
		       		{
					surroundingblock3[i].checkstatus=0;
				   	for(int j=0;j<16;j++)
				   	{ 
						if (Position(surroundingblock3[i])==Position(whitepiececenter[j]))
					 	{
					    		surroundingblock3[i].checkstatus=1;
		                			break;
		             			}
		           		}
		           		for(int j=0;j<16;j++)
				   	{ 
						if (Position(surroundingblock3[i])==Position(blackpiececenter[j]))
						{
							surroundingblock3[i].checkstatus=2;
					     		break;
		              			}
		           		}
		        	}
			}
			for(int i=0; i<(obj.GetXPosition()-2.0)/2.0; i++)
	    		{
				if(surroundingblock7[i].GetXDistance()<2.0 || surroundingblock7[i].GetYDistance()<1.5 || surroundingblock7[i].GetXDistance()>16.0 || surroundingblock7[i].GetYDistance()>15.5)			
		            		surroundingblock7[i].checkstatus=-1; // the move is out of the chessboard			
		       		else
		       		{
		        		surroundingblock7[i].checkstatus=0;
					for(int j=0;j<16;j++)
		       			{ 
				   		if (Position(surroundingblock7[i])==Position(whitepiececenter[j]))
				   		{
				      			surroundingblock7[i].checkstatus=1;
				      			break;
				   		}
		       			}
					for(int j=0;j<16;j++)
					{ 
						if (Position(surroundingblock7[i])==Position(blackpiececenter[j]))
						{
							surroundingblock7[i].checkstatus=2;
							break;
						}
					}
				}     
	    		}

			for(int i=0; i<(((1.5+7*2.0)-obj.GetYPosition())/2.0);i++)
			{
				if(surroundingblock5[i].GetXDistance()<2.0 || surroundingblock5[i].GetYDistance()<1.5 || surroundingblock5[i].GetXDistance()>16.0 || surroundingblock5[i].GetYDistance()>15.5)			
					surroundingblock5[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{
					surroundingblock5[i].checkstatus=0;
					for(int j=0;j<16;j++)
					{ 
						if (Position(surroundingblock5[i])==Position(whitepiececenter[j]))
						{
							surroundingblock5[i].checkstatus=1;
							break;
						}
					}

					for(int j=0;j<16;j++)
					{ 
						if (Position(surroundingblock5[i])==Position(blackpiececenter[j]))
						{
							surroundingblock5[i].checkstatus=2;
							break;
						}
					}
				}
	    		}

			for(int i=0; i<(obj.GetYPosition()-1.5)/2.0; i++)
		    	{
		        	if(surroundingblock1[i].GetXDistance()<2.0 || surroundingblock1[i].GetYDistance()<1.5 || surroundingblock1[i].GetXDistance()>16.0 || surroundingblock1[i].GetYDistance()>15.5)			
		        		surroundingblock1[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{
			       		surroundingblock1[i].checkstatus=0;
				        for(int j=0;j<16;j++)
			       		{ 
				   		if (Position(surroundingblock1[i])==Position(whitepiececenter[j]))
				   		{
					    		surroundingblock1[i].checkstatus=1;
				     	    		break;
				  	    	}
			       		}
			      		for(int j=0;j<16;j++)
			      		{ 
					   	if (Position(surroundingblock1[i])==Position(blackpiececenter[j]))
					   	{
						     surroundingblock1[i].checkstatus=2;
						     break;
					   	}
			      		}
				}     
			}     
		      	if(obj.GetXPosition()>=obj.GetYPosition())
	   		{
	    			for(int i=0; i<(((2.0+2.0*7)-obj.GetXPosition())/2.0); i++)
	    			{
		         		if(surroundingblock4[i].GetXDistance()<2.0 || surroundingblock4[i].GetYDistance()<1.5 || surroundingblock4[i].GetXDistance()>16.0 || surroundingblock4[i].GetYDistance()>15.5)			
		           			surroundingblock4[i].checkstatus=-1; // the move is out of the chessboard			
					else
					{
		    				surroundingblock4[i].checkstatus=0;
	    		    			for(int j=0;j<16;j++)
		    				{ 
		        				if (Position(surroundingblock4[i])==Position(whitepiececenter[j]))
		        				{
		          					surroundingblock4[i].checkstatus=1;
		          					break;
		        				}
		     				}
	    		     			for(int j=0;j<16;j++)
		     				{ 
		        				if (Position(surroundingblock4[i])==Position(blackpiececenter[j]))
		        				{
								surroundingblock4[i].checkstatus=2;
								break;
		        				}
		      				}
		  			}
	     			}
	    		}
	    		else
	    		{
	      			for(int i=0; i<(((1.5+2.0*7)-obj.GetYPosition())/2.0); i++)
	    			{
		          		 if(surroundingblock4[i].GetXDistance()<2.0 || surroundingblock4[i].GetYDistance()<1.5 || surroundingblock4[i].GetXDistance()>16.0 || surroundingblock4[i].GetYDistance()>15.5)			
		           			surroundingblock4[i].checkstatus=-1; // the move is out of the chessboard			
					else
					{
						surroundingblock4[i].checkstatus=0;

						for(int j=0;j<16;j++)
						{ 
		    					if (Position(surroundingblock4[i])==Position(whitepiececenter[j]))
		    					{
							      surroundingblock4[i].checkstatus=1;
							      break;
		    					}
		 				}
		 				for(int j=0;j<16;j++)
		 				{ 
		    					if (Position(surroundingblock4[i])==Position(blackpiececenter[j]))
		    					{
							       surroundingblock4[i].checkstatus=2;
							       break;
		    					}
		    				}
		  			}
	     			}
	    		}
			if(obj.GetXPosition()<=obj.GetYPosition())
	  		{
	    			for(int i=0; i<(obj.GetXPosition()-2.0)/2.0; i++)
	    			{
		         		if(surroundingblock8[i].GetXDistance()<2.0 || surroundingblock8[i].GetYDistance()<1.5 || surroundingblock8[i].GetXDistance()>16.0 || surroundingblock8[i].GetYDistance()>15.5)			
		           			surroundingblock8[i].checkstatus=-1; // the move is out of the chessboard			
					else
					{
	       					surroundingblock8[i].checkstatus=0;
						for(int j=0;j<16;j++)
						{ 
						   if (Position(surroundingblock8[i])==Position(whitepiececenter[j]))
						   {
						      surroundingblock8[i].checkstatus=1;
						      break;
						   }
						}
						for(int j=0;j<16;j++)
						{ 
						   if (Position(surroundingblock8[i])==Position(blackpiececenter[j]))
						   {
						     surroundingblock8[i].checkstatus=2;
						     break;
						   }
						}
	      				}
	    			}
	   		}
			else
			{
	    			for(int i=0; i<(obj.GetYPosition()-1.5)/2.0; i++)
	    			{
		    			if(surroundingblock8[i].GetXDistance()<2.0 || surroundingblock8[i].GetYDistance()<1.5 || surroundingblock8[i].GetXDistance()>16.0 || surroundingblock8[i].GetYDistance()>15.5)			
		           			surroundingblock8[i].checkstatus=-1; // the move is out of the chessboard			
					else
					{
	       					surroundingblock8[i].checkstatus=0;
						for(int j=0;j<16;j++)
						{ 
						   if (Position(surroundingblock8[i])==Position(whitepiececenter[j]))
						   {
						      surroundingblock8[i].checkstatus=1;
						      break;
						   }
	       					}

					      for(int j=0;j<16;j++)
					      { 
						   if (Position(surroundingblock8[i])==Position(blackpiececenter[j]))
						   {
						     surroundingblock8[i].checkstatus=2;
						     break;
						   }
						}
	      				}
	    			}
	   		}

	   		if(obj.GetXPosition()<=obj.GetYPosition())
	   		{
	      			for(int i=0; i<(obj.GetXPosition()-2.0)/2.0;i++)
	      			{
		      			if(surroundingblock6[i].GetXDistance()<2.0 || surroundingblock6[i].GetYDistance()<1.5 || surroundingblock6[i].GetXDistance()>16.0 || surroundingblock6[i].GetYDistance()>15.5)			
		           			surroundingblock6[i].checkstatus=-1; // the move is out of the chessboard			
					else
					{
						surroundingblock6[i].checkstatus=0;
						for(int j=0;j<16;j++)
						{ 
						    if (Position(surroundingblock6[i])==Position(whitepiececenter[j]))
						    {
						      surroundingblock6[i].checkstatus=1;
						      break;
						    }
						}

						for(int j=0;j<16;j++)
						{ 
						    if (Position(surroundingblock6[i])==Position(blackpiececenter[j]))
						    {
						       surroundingblock6[i].checkstatus=2;
						       break;
						    }
						}
	     
	     				}
	     			}
	    		}
	 
	    		else
	    		{
	      			for(int i=0; i<(((1.5+7*2.0)-obj.GetYPosition())/2.0);i++)
	      			{
		      			if(surroundingblock6[i].GetXDistance()<2.0 || surroundingblock6[i].GetYDistance()<1.5 || surroundingblock6[i].GetXDistance()>16.0 || surroundingblock6[i].GetYDistance()>15.5)			
		           			surroundingblock6[i].checkstatus=-1; // the move is out of the chessboard			
					else
					{
						surroundingblock6[i].checkstatus=0;
						for(int j=0;j<16;j++)
						{ 
						    if (Position(surroundingblock6[i])==Position(whitepiececenter[j]))
						    {
						      surroundingblock6[i].checkstatus=1;
						      break;
						    }
						}

						for(int j=0;j<16;j++)
						{ 
						    if (Position(surroundingblock6[i])==Position(blackpiececenter[j]))
						    {
						       surroundingblock6[i].checkstatus=2;
						       break;
						    }
						}
					}
	     			}
	    		}
	    
	    		if(obj.GetXPosition()>=obj.GetYPosition())
	    		{
	     			for(int i=0; i<(((2.0+7*2.0)-obj.GetXPosition())/2.0); i++)
	     			{
		       			if(surroundingblock2[i].GetXDistance()<2.0 || surroundingblock2[i].GetYDistance()<1.5 || surroundingblock2[i].GetXDistance()>16.0 || surroundingblock2[i].GetYDistance()>15.5)			
		           			surroundingblock2[i].checkstatus=-1; // the move is out of the chessboard			
					else
					{
	       					surroundingblock2[i].checkstatus=0;
	       					for(int j=0;j<16;j++)
	       					{ 
						   if (Position(surroundingblock2[i])==Position(whitepiececenter[j]))
						   {
						      surroundingblock2[i].checkstatus=1;
						      break;
						   }
					        }
					        for(int j=0;j<16;j++)
					        { 
						   if (Position(surroundingblock2[i])==Position(blackpiececenter[j]))
						   {
						     surroundingblock2[i].checkstatus=2;
						     break;
						   }
					        }
	      				}
	     			}
	    		}
	    		else
		     	{
			     	for(int i=0;  i<(obj.GetYPosition()-1.5)/2.0; i++)
			     	{
					if(surroundingblock2[i].GetXDistance()<2.0 || surroundingblock2[i].GetYDistance()<1.5 || surroundingblock2[i].GetXDistance()>16.0 || surroundingblock2[i].GetYDistance()>15.5)			
						surroundingblock2[i].checkstatus=-1; // the move is out of the chessboard			
					else
					{
					       surroundingblock2[i].checkstatus=0;
					       for(int j=0;j<16;j++)
					       { 
						   if (Position(surroundingblock2[i])==Position(whitepiececenter[j]))
						   {
						      surroundingblock2[i].checkstatus=1;
						      break;
						   }
					       }
					      for(int j=0;j<16;j++)
					      { 
						   if (Position(surroundingblock2[i])==Position(blackpiececenter[j]))
						   {
						     surroundingblock2[i].checkstatus=2;
						     break;
						   }
					      }
		      
		     			}
				}
	    	   	}	   
		}   	   
	    	   
	    	   
		// Getting all valid moves
		void validate()
		{	    
			int c=0;
			for(int i=0; i<(((2.0+2.0*7)-obj.GetXPosition())/2.0); i++)
		    	{
			      if (surroundingblock3[i].checkstatus==0)
			      {
				validmoves[c]= surroundingblock3[i];
				c++;
			      }

			      else if (surroundingblock3[i].checkstatus==2)
			      {
				validmoves[c]= surroundingblock3[i];
				c++;
				break;
			      }

			      else
			      {
				break;
			      }
		    	}

		    	for(int i=0; i<(obj.GetXPosition()-2.0)/2.0; i++)
		    	{
			      if (surroundingblock7[i].checkstatus==0)
			      {
				validmoves[c]= surroundingblock7[i];
				c++;
			      }

			      else if (surroundingblock7[i].checkstatus==2)
			      {
				validmoves[c]= surroundingblock7[i];
				c++;
				break;
			      }

			      else
			      {
				break;
			      }
		    	}

		    	for(int i=0; i<(obj.GetYPosition()-1.5)/2.0; i++)
		    	{
			      if (surroundingblock1[i].checkstatus==0)
			      {
				validmoves[c]= surroundingblock1[i];
				c++;
			      }

			      else if (surroundingblock1[i].checkstatus==2)
			      {
				validmoves[c]= surroundingblock1[i];
				c++;			
				break;
			      }

			      else
			      {
				break;
			      }
		    	}

		    	for(int i=0; i<(((1.5+7*2.0)-obj.GetYPosition())/2.0);i++)
		    	{
			      if (surroundingblock5[i].checkstatus==0)
			      {
				validmoves[c]= surroundingblock5[i];
				c++;
			      }

			      else if (surroundingblock5[i].checkstatus==2)
			      {
				validmoves[c]= surroundingblock5[i];
				c++;
				break;
			      }

			      else
			      {
				break;
			      }
		    	}
		    
		    
		  	if(obj.GetXPosition()>=obj.GetYPosition())
	    		{
	   
				for(int i=0; i<(((2.0+2.0*7)-obj.GetXPosition())/2.0); i++)
				{
					if (surroundingblock4[i].checkstatus==0)
					{
					validmoves[c]= surroundingblock4[i];
					c++;
					}

					else if (surroundingblock4[i].checkstatus==2)
					{
					validmoves[c]= surroundingblock4[i];
						c++;
					break;
					}

					else
					{
					break;
					}
				}
	     		}
	     		else
	     		{      
				for(int i=0; i<(((1.5+2.0*7)-obj.GetYPosition())/2.0); i++)
		    		{
				      if (surroundingblock4[i].checkstatus==0)
				      {
					validmoves[c]= surroundingblock4[i];
						c++;
				      }

				      else if (surroundingblock4[i].checkstatus==2)
				      {
					validmoves[c]= surroundingblock4[i];
						c++;
					break;
				      }

				      else
				      {
					break;
				      }
		    		}
	     		}
	    		if(obj.GetXPosition()<=obj.GetYPosition())
	    		{

		    		for(int i=0; i<(obj.GetXPosition()-2.0)/2.0; i++)
		    		{
				      if (surroundingblock8[i].checkstatus==0)
				      {
					validmoves[c]= surroundingblock8[i];
						c++;
				      }

				      else if (surroundingblock8[i].checkstatus==2)
				      {
					validmoves[c]= surroundingblock8[i];
					c++;
					break;
				      }

				      else
				      {
					break;
				      }
		    		}
	    		}

	    		else
	    		{
				for(int i=0; i<(obj.GetYPosition()-1.5)/2.0; i++) 
				{
				      if (surroundingblock8[i].checkstatus==0)
				      {
					validmoves[c]= surroundingblock8[i];
					c++;
				      }

				      else if (surroundingblock8[i].checkstatus==2)
				      {
					validmoves[c]= surroundingblock8[i];
					c++;
					break;
				      }

				      else
				      {
					break;
				      }
		    		}
	     		} 
		    	
			if(obj.GetXPosition()>=obj.GetYPosition())
		    	{
				for(int i=0; i<(((2.0+2.0*7)-obj.GetXPosition())/2.0); i++)
			      	{
				      if (surroundingblock2[i].checkstatus==0)
				      {
					validmoves[c]= surroundingblock2[i];
					c++;
				      }

				      else if (surroundingblock2[i].checkstatus==2)
				      {
					validmoves[c]= surroundingblock2[i];
					c++;
					break;
				      }

				      else
				      {
					break;
				      }
			    	}
		    	}

	    		else
	    		{	   
		      		for(int i=0; i<(obj.GetYPosition()-1.5)/2.0; i++)
		      		{
				      if (surroundingblock2[i].checkstatus==0)
				      {
					validmoves[c]= surroundingblock2[i];
					c++;
				      }

				      else if (surroundingblock2[i].checkstatus==2)
				      {
					validmoves[c]= surroundingblock2[i];
					c++;
					break;
				      }

				      else
				      {
					break;
				      }
		    		}
	    		}

	    		if(obj.GetXPosition()>=obj.GetYPosition())
	    		{ 
		    		for(int i=0; i<(((1.5+7*2.0)-obj.GetYPosition())/2.0);i++)
		    		{
				      if (surroundingblock6[i].checkstatus==0)
				      {
					validmoves[c]= surroundingblock6[i];
					c++;
				      }

				      else if (surroundingblock6[i].checkstatus==2)
				      {
					validmoves[c]= surroundingblock6[i];
					c++;
					break;
				      }

				      else
				      {
					break;
				      }
		    		}
	     		}
	 
	    		else
	    		{
				for(int i=0; i<(obj.GetXPosition()-2.0)/2.0; i++)
		    		{
				      if (surroundingblock6[i].checkstatus==0)
				      {
					validmoves[c]= surroundingblock6[i];
					c++;
				      }

				      else if (surroundingblock6[i].checkstatus==2)
				      {
					validmoves[c]=surroundingblock6[i];
					c++;
					break;
				      }

				      else
				      {
					break;
				      }
		    		}
	    		}
	  	}
	  
	  
	  	int compare(Position c)                  //this function finds out whetehr the click made lies in the valid moves or not
		{
		  int flag=0;
		  	for(int i=0;i<14;i++)
			{	
				if(validmoves[i].checkstatus!=-1)
				{
					if(Position(c)==Position(validmoves[i]))
					{
						if(validmoves[i].checkstatus==0)
						{
							flag=1;
							break;
						}
						else if(validmoves[i].checkstatus==2)
						{
							flag=2;
							break;
						}
					}
				}
			}	
		   
		   return flag;	
		}
	}wq;




	//Class for black queen's moves and valid positions.
	class bqueenmove
	{
	      public:
		BitMap obj;
		int life;  //If life=0, queen is dead else if life=1, queen is alive.
		newpos surroundingblock1[7];
		newpos surroundingblock2[7];
		newpos surroundingblock3[7];
		newpos surroundingblock4[7];
		newpos surroundingblock5[7];
		newpos surroundingblock6[7];
		newpos surroundingblock7[7];
		newpos surroundingblock8[7];
		//The above arrays will store the number of surrounding blocks depending on the current position of the queen.
		newpos validmoves[28];
	
		//The above arrays will contain the valid positions where the queen can move.

		void initialise()       //Member function.
		{
			for(int i=obj.GetXPosition()+2.0,c=0; i<=2.0+2.0*7; i+=2.0,c++)       //(x,y) is the center coordinate of the piece
			{
				surroundingblock3[c].SetXDistance(i);
				surroundingblock3[c].SetYDistance(obj.GetYPosition());
	      		}
	  
	      		for(int i=obj.GetXPosition()-2.0,c=0; i>=2.0; i-=2.0,c++)
	      		{
				surroundingblock7[c].SetXDistance(i);
				surroundingblock7[c].SetYDistance(obj.GetYPosition());
	      		}
	 
	      		for(int i=obj.GetYPosition()-2.0,c=0; i>=1.5; i-=2.0,c++)
	      		{
				surroundingblock1[c].SetYDistance(i);
				surroundingblock1[c].SetXDistance(obj.GetXPosition());
	      		}
	   
	      		for(int i=obj.GetYPosition()+2.0,c=0; i<=1.5+2.0*7; i+=2.0,c++)
	      		{
				surroundingblock5[c].SetYDistance(i);
				surroundingblock5[c].SetXDistance(obj.GetXPosition());
	      		}
	      
		      	for(int i=obj.GetXPosition()+2.0,j=obj.GetYPosition()+2.0,c=0; i<=2.0+2.0*7,j<=1.5+7*2.0; i+=2.0,j+=2.0,c++)
		      	{
				surroundingblock4[c].SetXDistance(i);
				surroundingblock4[c].SetYDistance(j);
		      	}
	  
	      		for(int i=obj.GetXPosition()-2.0,j=obj.GetYPosition()-2.0,c=0; i>=2.0,j>=1.5; i-=2.0,j-=2.0,c++)
	      		{
				surroundingblock8[c].SetXDistance(i);
				surroundingblock8[c].SetYDistance(j);
	      		}
	 
	      		for(int i=obj.GetXPosition()+2.0,j=obj.GetYPosition()-2.0,c=0;i<=2.0+2.0*7 ,j>=1.5; i+=2.0,j-=2.0,c++)
	      		{
				surroundingblock2[c].SetXDistance(i);
				surroundingblock2[c].SetYDistance(j);
	      		}
	   
	      		for(int i=obj.GetXPosition()-2.0,j=obj.GetYPosition()+2.0,c=0; i>=2.0,j<=1.5+2.0*7; i-=2.0,j+=2.0,c++)
	      		{
				surroundingblock6[c].SetXDistance(i);
				surroundingblock6[c].SetYDistance(j);
	      		}
		}
	      
	      
	 	// Getting value of checkstatus for each block 
	  	void checkposition()
	  	{
	    		for(int i=0; i<(((2.0+2.0*7)-obj.GetXPosition())/2.0); i++)
	    		{
		        	if(surroundingblock3[i].GetXDistance()<2.0 || surroundingblock3[i].GetYDistance()<1.5 || surroundingblock3[i].GetXDistance()>16.0 || surroundingblock3[i].GetYDistance()>15.5)			
		           		surroundingblock3[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{
					surroundingblock3[i].checkstatus=0;
					for(int j=0;j<16;j++)
					{ 
					    if (Position(surroundingblock3[i])==Position(blackpiececenter[j]))
					    {
					      surroundingblock3[i].checkstatus=1;
					      break;
					    }
					}
					for(int j=0;j<16;j++)
					{ 
					    if (Position(surroundingblock3[i])==Position(whitepiececenter[j]))
					    {
					       surroundingblock3[i].checkstatus=2;
					       break;
					    }
					}
	  			}
	     		}

	    		for(int i=0; i<(obj.GetXPosition()-2.0)/2.0; i++)
	    		{
		                if(surroundingblock7[i].GetXDistance()<2.0 || surroundingblock7[i].GetYDistance()<1.5 || surroundingblock7[i].GetXDistance()>16.0 || surroundingblock7[i].GetYDistance()>15.5)			
		           		surroundingblock7[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{
		       			surroundingblock7[i].checkstatus=0;
	       				for(int j=0;j<16;j++)
		       			{ 
					   if (Position(surroundingblock7[i])==Position(blackpiececenter[j]))
					   {
					      surroundingblock7[i].checkstatus=1;
					      break;
					   }
		       			}

		       			for(int j=0;j<16;j++)
		       			{ 
					   if (Position(surroundingblock7[i])==Position(whitepiececenter[j]))
					   {
					     surroundingblock7[i].checkstatus=2;
					     break;
					   }
		       			}
				}
	    		}

	    		for(int i=0; i<(((1.5+7*2.0)-obj.GetYPosition())/2.0);i++)
	    		{
		                if(surroundingblock5[i].GetXDistance()<2.0 || surroundingblock5[i].GetYDistance()<1.5 || surroundingblock5[i].GetXDistance()>16.0 || surroundingblock5[i].GetYDistance()>15.5)			
		           		surroundingblock5[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{
					surroundingblock5[i].checkstatus=0;
					for(int j=0;j<16;j++)
					{ 
					    if (Position(surroundingblock5[i])==Position(blackpiececenter[j]))
					    {
					      surroundingblock5[i].checkstatus=1;
					      break;
					    }
		 			}

		 			for(int j=0;j<16;j++)
		 			{ 
					    if (Position(surroundingblock5[i])==Position(whitepiececenter[j]))
					    {
					       surroundingblock5[i].checkstatus=2;
					       break;
					    }
		 			}
				}
	    		}

		    	for(int i=0; i<(obj.GetYPosition()-1.5)/2.0; i++)
		    	{
		                if(surroundingblock1[i].GetXDistance()<2.0 || surroundingblock1[i].GetYDistance()<1.5 || surroundingblock1[i].GetXDistance()>16.0 || surroundingblock1[i].GetYDistance()>15.5)			
		           		surroundingblock1[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{
			       		surroundingblock1[i].checkstatus=0;
			       		for(int j=0;j<16;j++)
			       		{ 
				   	    if (Position(surroundingblock1[i])==Position(blackpiececenter[j]))
				   	    {
					    surroundingblock1[i].checkstatus=1;
				     	    break;
				  	    }
			       		}

			      		for(int j=0;j<16;j++)
			      		{ 
					   if (Position(surroundingblock1[i])==Position(whitepiececenter[j]))
					   {
					     surroundingblock1[i].checkstatus=2;
					     break;
					   }
			      		}
		      		}
		     	}
		      	if(obj.GetXPosition()>=obj.GetYPosition())
	   		{
	    			for(int i=0; i<(((2.0+2.0*7)-obj.GetXPosition())/2.0); i++)
	    			{
		            		if(surroundingblock4[i].GetXDistance()<2.0 || surroundingblock4[i].GetYDistance()<1.5 || surroundingblock4[i].GetXDistance()>16.0 || surroundingblock4[i].GetYDistance()>15.5)			
		           			surroundingblock4[i].checkstatus=-1; // the move is out of the chessboard			
					else
					{
						surroundingblock4[i].checkstatus=0;
						for(int j=0;j<16;j++)
						{ 
		    					if (Position(surroundingblock4[i])==Position(blackpiececenter[j]))
		    					{
		      						surroundingblock4[i].checkstatus=1;
		      						break;
		    					}
		 				}

		 				for(int j=0;j<16;j++)
		 				{ 
		    					if (Position(surroundingblock4[i])==Position(whitepiececenter[j]))
		                			{
							       surroundingblock4[i].checkstatus=2;
							       break;
		    					}
		  				}
		  			}
	     			}
	    		}
		    	else
		   	{
	      			for(int i=0; i<(((1.5+2.0*7)-obj.GetYPosition())/2.0); i++)
	    			{
		        		if(surroundingblock4[i].GetXDistance()<2.0 || surroundingblock4[i].GetYDistance()<1.5 || surroundingblock4[i].GetXDistance()>16.0 || surroundingblock4[i].GetYDistance()>15.5)			
		           			surroundingblock4[i].checkstatus=-1; // the move is out of the chessboard			
					else
					{
						surroundingblock4[i].checkstatus=0;
						for(int j=0;j<16;j++)
						{ 
						    if (Position(surroundingblock4[i])==Position(blackpiececenter[j]))
						    {
						      surroundingblock4[i].checkstatus=1;
						      break;
						    }
						}

						for(int j=0;j<16;j++)
						{ 
						    if (Position(surroundingblock4[i])==Position(whitepiececenter[j]))
						    {
						       surroundingblock4[i].checkstatus=2;
						       break;
						    }
						}
		  			}
	     			}
	    		}

	  		if(obj.GetXPosition()<=obj.GetYPosition())
	  		{

	    			for(int i=0; i<(obj.GetXPosition()-2.0)/2.0; i++)
	    			{
		      			if(surroundingblock8[i].GetXDistance()<2.0 || surroundingblock8[i].GetYDistance()<1.5 || surroundingblock8[i].GetXDistance()>16.0 || surroundingblock8[i].GetYDistance()>15.5)			
		           			surroundingblock8[i].checkstatus=-1; // the move is out of the chessboard			
					else
					{
	       					surroundingblock8[i].checkstatus=0;
	       					for(int j=0;j<16;j++)
	       					{ 
						   if (Position(surroundingblock8[i])==Position(blackpiececenter[j]))
						   {
						      surroundingblock8[i].checkstatus=1;
						      break;
						   }
	       					}

	      					for(int j=0;j<16;j++)
	      					{ 
						   if (Position(surroundingblock8[i])==Position(whitepiececenter[j]))
						   {
						     surroundingblock8[i].checkstatus=2;
						     break;
						   }
	     					}
	      				}
	    			}
	   		}
	   
	   		else
	   		{

	    			for(int i=0; i<(obj.GetYPosition()-1.5)/2.0; i++)
	    			{
		           		if(surroundingblock8[i].GetXDistance()<2.0 || surroundingblock8[i].GetYDistance()<1.5 || surroundingblock8[i].GetXDistance()>16.0 || surroundingblock8[i].GetYDistance()>15.5)			
		           			surroundingblock8[i].checkstatus=-1; // the move is out of the chessboard			
					else
					{
	       					surroundingblock8[i].checkstatus=0;
	       					for(int j=0;j<16;j++)
	       					{ 
						   if (Position(surroundingblock8[i])==Position(blackpiececenter[j]))
						   {
						      surroundingblock8[i].checkstatus=1;
						      break;
						   }
	       					}

	      					for(int j=0;j<16;j++)
	      					{ 
						   if (Position(surroundingblock8[i])==Position(whitepiececenter[j]))
						   {
						     surroundingblock8[i].checkstatus=2;
						     break;
						   }
	      					}
	      				}
	    			}
	   		}

	   		if(obj.GetXPosition()<=obj.GetYPosition())
	   		{

	      			for(int i=0; i<(obj.GetXPosition()-2.0)/2.0;i++)
	      			{
		             		if(surroundingblock6[i].GetXDistance()<2.0 || surroundingblock6[i].GetYDistance()<1.5 || surroundingblock6[i].GetXDistance()>16.0 || surroundingblock6[i].GetYDistance()>15.5)			
		           			surroundingblock6[i].checkstatus=-1; // the move is out of the chessboard			
					else
					{
						surroundingblock6[i].checkstatus=0;
						for(int j=0;j<16;j++)
						{ 
						    if (Position(surroundingblock6[i])==Position(blackpiececenter[j]))
						    {
						      surroundingblock6[i].checkstatus=1;
						      break;
						    }
		 				}

		 				for(int j=0;j<16;j++)
		 				{ 
						    if (Position(surroundingblock6[i])==Position(whitepiececenter[j]))
						    {
						       surroundingblock6[i].checkstatus=2;
						       break;
						    }
		  				}
		  			}
	     			}
	    		}
	 
	    		else
	    		{

	      			for(int i=0; i<(((1.5+7*2.0)-obj.GetYPosition())/2.0);i++)
	      			{
		                	if(surroundingblock6[i].GetXDistance()<2.0 || surroundingblock6[i].GetYDistance()<1.5 || surroundingblock6[i].GetXDistance()>16.0 || surroundingblock6[i].GetYDistance()>15.5)			
		           			surroundingblock6[i].checkstatus=-1; // the move is out of the chessboard			
					else
					{
						surroundingblock6[i].checkstatus=0;
						for(int j=0;j<16;j++)
						{ 
						    if (Position(surroundingblock6[i])==Position(blackpiececenter[j]))
						    {
						      surroundingblock6[i].checkstatus=1;
						      break;
						    }
		 				}

		 				for(int j=0;j<16;j++)
		 				{ 
						    if (Position(surroundingblock6[i])==Position(whitepiececenter[j]))
						    {
						       surroundingblock6[i].checkstatus=2;
						       break;
						    }
		  				}
	     				}
	    			}
			}
	    
	    		if(obj.GetXPosition()>=obj.GetYPosition())
	    		{
	     			for(int i=0; i<(((2.0+7*2.0)-obj.GetXPosition())/2.0); i++)
	     			{
		                	if(surroundingblock2[i].GetXDistance()<2.0 || surroundingblock2[i].GetYDistance()<1.5 || surroundingblock2[i].GetXDistance()>16.0 || surroundingblock2[i].GetYDistance()>15.5)			
		           			surroundingblock2[i].checkstatus=-1; // the move is out of the chessboard			
					else
					{
	       					surroundingblock2[i].checkstatus=0;
	       					for(int j=0;j<16;j++)
	       					{ 
						   if (Position(surroundingblock2[i])==Position(blackpiececenter[j]))
						   {
						      surroundingblock2[i].checkstatus=1;
						      break;
						   }
	       					}

	      					for(int j=0;j<16;j++)
	      					{ 
						   if (Position(surroundingblock2[i])==Position(whitepiececenter[j]))
						   {
						     surroundingblock2[i].checkstatus=2;
						     break;
						   }
      					
						}
	      				}
	     			}
	    		}
	    		else
	     		{
	     			for(int i=0;  i<(obj.GetYPosition()-1.5)/2.0; i++)
	     			{
		                	if(surroundingblock2[i].GetXDistance()<2.0 || surroundingblock2[i].GetYDistance()<1.5 || surroundingblock2[i].GetXDistance()>16.0 || surroundingblock2[i].GetYDistance()>15.5)			
		           			surroundingblock2[i].checkstatus=-1; // the move is out of the chessboard			
					else
					{
	       					surroundingblock2[i].checkstatus=0;
	       					for(int j=0;j<16;j++)
	       					{ 
		   					if (Position(surroundingblock2[i])==Position(blackpiececenter[j]))
		   					{
							      surroundingblock2[i].checkstatus=1;
							      break;
		   					}
	       					}

	      					for(int j=0;j<16;j++)
	      					{ 
						   if (Position(surroundingblock2[i])==Position(whitepiececenter[j]))
						   {
						     surroundingblock2[i].checkstatus=2;
						     break;
						   }
	      					}
	      				}
	     			}
		      
	    	   	}
	    	}	   
	    	   
	    	   
		// Getting all valid moves
		  void validate()
		  {	    int c=0;
			    for(int i=0; i<(((2.0+2.0*7)-obj.GetXPosition())/2.0); i++)
			    {
				      if (surroundingblock3[i].checkstatus==0)
				      {
					validmoves[c]= surroundingblock3[i];
					c++;
				      }

				      else if (surroundingblock3[i].checkstatus==2)
				      {
					validmoves[c]= surroundingblock3[i];
					c++;
					break;
				      }

				      else
				      {
					break;
				      }
			    }

			    for(int i=0; i<(obj.GetXPosition()-2.0)/2.0; i++)
			    {
				      if (surroundingblock7[i].checkstatus==0)
				      {
					validmoves[c]= surroundingblock7[i];
					c++;
				      }

				      else if (surroundingblock7[i].checkstatus==2)
				      {
					validmoves[c]= surroundingblock7[i];
					c++;
					break;
				      }

				      else
				      {
					break;
				      }
			    }

			    for(int i=0; i<(obj.GetYPosition()-1.5)/2.0; i++)
			    {
				      if (surroundingblock1[i].checkstatus==0)
				      {
					validmoves[c]= surroundingblock1[i];
					c++;
				      }

				      else if (surroundingblock1[i].checkstatus==2)
				      {
					validmoves[c]= surroundingblock1[i];
					c++;			
					break;
				      }

				      else
				      {
					break;
				      }
			    }

			    for(int i=0; i<(((1.5+7*2.0)-obj.GetYPosition())/2.0);i++)
			    {
				      if (surroundingblock5[i].checkstatus==0)
				      {
					validmoves[c]= surroundingblock5[i];
					c++;
				      }

				      else if (surroundingblock5[i].checkstatus==2)
				      {
					validmoves[c]= surroundingblock5[i];
					c++;
					break;
				      }

				      else
				      {
					break;
				      }
			    }
		            if(obj.GetXPosition()>=obj.GetYPosition())
	                    {
	   
				    for(int i=0; i<(((2.0+2.0*7)-obj.GetXPosition())/2.0); i++)
				    {
					      if (surroundingblock4[i].checkstatus==0)
					      {
						validmoves[c]= surroundingblock4[i];
						c++;
					      }

					      else if (surroundingblock4[i].checkstatus==2)
					      {
						validmoves[c]= surroundingblock4[i];
						c++;
						break;
					      }

					      else
					      {
						break;
					      }
				    }
	     		   }
		           else
	     		   {
      				    for(int i=0; i<(((1.5+2.0*7)-obj.GetYPosition())/2.0); i++)
				    {
					      if (surroundingblock4[i].checkstatus==0)
					      {
						validmoves[c]= surroundingblock4[i];
						c++;
					      }

					      else if (surroundingblock4[i].checkstatus==2)
					      {
						validmoves[c]= surroundingblock4[i];
						c++;
						break;
					      }

					      else
					      {
						break;
					      }
				    }
	     		}
	    		if(obj.GetXPosition()<=obj.GetYPosition())
	    		{

			    for(int i=0; i<(obj.GetXPosition()-2.0)/2.0; i++)
			    {
				      if (surroundingblock8[i].checkstatus==0)
				      {
					validmoves[c]= surroundingblock8[i];
					c++;
				      }

				      else if (surroundingblock8[i].checkstatus==2)
				      {
					validmoves[c]= surroundingblock8[i];
					c++;
					break;
				      }

				      else
				      {
					break;
				      }
			    }
	    		}

	    		else
	    		{
			    for(int i=0; i<(obj.GetYPosition()-1.5)/2.0; i++) 
			    {
				      if (surroundingblock8[i].checkstatus==0)
				      {
					validmoves[c]= surroundingblock8[i];
					c++;
				      }

				      else if (surroundingblock8[i].checkstatus==2)
				      {
					validmoves[c]= surroundingblock8[i];
					c++;
					break;
				      }

				      else
				      {
					break;
				      }
			    } 
	     		}
	    		if(obj.GetXPosition()>=obj.GetYPosition())
	    		{
		 	      for(int i=0; i<(((2.0+2.0*7)-obj.GetXPosition())/2.0); i++)
			      {
				      if (surroundingblock2[i].checkstatus==0)
				      {
					validmoves[c]= surroundingblock2[i];
					c++;
				      }

				      else if (surroundingblock2[i].checkstatus==2)
				      {
					validmoves[c]= surroundingblock2[i];
					c++;
					break;
				      }

				      else
				      {
					break;
				      }
			     }
	    		}

	    		else
	    		{	   
			      for(int i=0; i<(obj.GetYPosition()-1.5)/2.0; i++)
			      {
				      if (surroundingblock2[i].checkstatus==0)
				      {
					validmoves[c]= surroundingblock2[i];
					c++;
				      }

				      else if (surroundingblock2[i].checkstatus==2)
				      {
					validmoves[c]= surroundingblock2[i];
					c++;
					break;
				      }

				      else
				      {
					break;
				      }
			    }
	    		}

	    		if(obj.GetXPosition()>=obj.GetYPosition())
	    		{ 
			    for(int i=0; i<(((1.5+7*2.0)-obj.GetYPosition())/2.0);i++)
			    {
				      if (surroundingblock6[i].checkstatus==0)
				      {
					validmoves[c]= surroundingblock6[i];
					c++;
				      }

				      else if (surroundingblock6[i].checkstatus==2)
				      {
					validmoves[c]= surroundingblock6[i];
					c++;
					break;
				      }

				      else
				      {
					break;
				      }
			    }
	     		}
	 
	    		else
	    		{
		            for(int i=0; i<(obj.GetXPosition()-2.0)/2.0; i++)
			    {
				      if (surroundingblock6[i].checkstatus==0)
				      {
					validmoves[c]= surroundingblock6[i];
					c++;
				      }

				      else if (surroundingblock6[i].checkstatus==2)
				      {
					validmoves[c]= surroundingblock6[i];
					c++;
					break;
				      }

				      else
				      {
					break;
				      }
			    }
	   		}
	  	}
	  
	  	int compare(Position c)                  //this function finds out whetehr the click made lies in the valid moves or not
		{
		  int flag=0;
		  	for(int i=0;i<14;i++)
			{	
				if(validmoves[i].checkstatus!=-1)
				{
					if(Position(c)==Position(validmoves[i]))
					{
						if(validmoves[i].checkstatus==0)
						{
							flag=1;
							break;
						}
						else if(validmoves[i].checkstatus==2)
						{
							flag=2;
							break;
						}
					}
				}
			}	
		   
		   return flag;	
		}
	  
	}bq;



	class wbishopmove
	{
	  public:
	  //data members
	  BitMap obj;
	  int temp; // temp=0 when it can move 1 sides, temp=1 when it can move 2 sides, and temp=2 when it can move all 4 sides  
	  int move; // move=0 bishop hasnt moved yet     move=1 bishop has moved atleast once
	  int life; // life=0 if dead and life=1 if alive
	  newpos surroundingblock1[7];
	  newpos surroundingblock2[7];
	  newpos surroundingblock3[7];
	  newpos surroundingblock4[7];
	  newpos validmoves[14];
	  //member functions

	// Entering positions of surrounding blocks
	  void initialise()
	  {
	      for(int i=obj.GetXPosition()+2.0,j=obj.GetYPosition()+2.0,c=0; i<=2.0+2.0*7,j<=1.5+7*2.0; i+=2.0,j+=2.0,c++)
	      {
		surroundingblock1[c].SetXDistance(i);
		surroundingblock1[c].SetYDistance(j);
	      }
	  
	      for(int i=obj.GetXPosition()-2.0,j=obj.GetYPosition()-2.0,c=0; i>=2.0,j>=1.5; i-=2.0,j-=2.0,c++)
	      {
		surroundingblock2[c].SetXDistance(i);
		surroundingblock2[c].SetYDistance(j);
	      }
	 
	      for(int i=obj.GetXPosition()+2.0,j=obj.GetYPosition()-2.0,c=0;i<=2.0+2.0*7 ,j>=1.5; i+=2.0,j-=2.0,c++)
	      {
		surroundingblock3[c].SetXDistance(i);
		surroundingblock3[c].SetYDistance(j);
	      }
	   
	      for(int i=obj.GetXPosition()-2.0,j=obj.GetYPosition()+2.0,c=0; i>=2.0,j<=1.5+2.0*7; i-=2.0,j+=2.0,c++)
	      {
		surroundingblock4[c].SetXDistance(i);
		surroundingblock4[c].SetYDistance(j);
	      } 
	  }

	  // Getting value of checkstatus for each block 
	  void checkposition()
	  {
	  	if(obj.GetXPosition()>=obj.GetYPosition())
	   	{
		     
	    		for(int i=0; i<(((2.0+2.0*7)-obj.GetXPosition())/2.0); i++)
	    		{
		    		if(surroundingblock1[i].GetXDistance()<2.0 || surroundingblock1[i].GetYDistance()<1.5 || surroundingblock1[i].GetXDistance()>16.0 || surroundingblock1[i].GetYDistance()>15.5)			
		           		surroundingblock1[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{

					surroundingblock1[i].checkstatus=0;

					for(int j=0;j<16;j++)
					{ 
					    if (Position(surroundingblock1[i])==Position(whitepiececenter[j]))
					    {
					      surroundingblock1[i].checkstatus=1;
					      break;
					    }
		 			}

		 			for(int j=0;j<16;j++)
		 			{ 
					    if (Position(surroundingblock1[i])==Position(blackpiececenter[j]))
					    {
					       surroundingblock1[i].checkstatus=2;
					       break;
					    }
		  			}
	     			}
	    		}
	    	}
	    	else
	    	{
	      		for(int i=0; i<(((1.5+2.0*7)-obj.GetYPosition())/2.0); i++)
	    		{
		      		if(surroundingblock1[i].GetXDistance()<2.0 || surroundingblock1[i].GetYDistance()<1.5 || surroundingblock1[i].GetXDistance()>16.0 || surroundingblock1[i].GetYDistance()>15.5)			
		           		surroundingblock1[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{

					surroundingblock1[i].checkstatus=0;

					for(int j=0;j<16;j++)
					{ 
					    if (Position(surroundingblock1[i])==Position(whitepiececenter[j]))
					    {
					      surroundingblock1[i].checkstatus=1;
					      break;
					    }
		 			}

		 			for(int j=0;j<16;j++)
		 			{ 
					    if (Position(surroundingblock1[i])==Position(blackpiececenter[j]))
					    {
					       surroundingblock1[i].checkstatus=2;
					       break;
					    }
		  			}
	     			}
	    		}
		}

	  	if(obj.GetXPosition()<=obj.GetYPosition())
	  	{
		 	for(int i=0; i<(obj.GetXPosition()-2.0)/2.0; i++)
	    		{
		 		if(surroundingblock2[i].GetXDistance()<2.0 || surroundingblock2[i].GetYDistance()<1.5 || surroundingblock2[i].GetXDistance()>16.0 || surroundingblock2[i].GetYDistance()>15.5)			
		           		surroundingblock2[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{

		       			surroundingblock2[i].checkstatus=0;

		       			for(int j=0;j<16;j++)
		       			{ 
					   if (Position(surroundingblock2[i])==Position(whitepiececenter[j]))
					   {
					      surroundingblock2[i].checkstatus=1;
					      break;
					   }
		       			}

		      			for(int j=0;j<16;j++)
		      			{ 
					   if (Position(surroundingblock2[i])==Position(blackpiececenter[j]))
					   {
					     surroundingblock2[i].checkstatus=2;
					     break;
					   }
		      			}
	      
	    			}
	   		}
		}
	   	else
	   	{

	    		for(int i=0; i<(obj.GetYPosition()-1.5)/2.0; i++)
	    		{
		  		if(surroundingblock2[i].GetXDistance()<2.0 || surroundingblock2[i].GetYDistance()<1.5 || surroundingblock2[i].GetXDistance()>16.0 || surroundingblock2[i].GetYDistance()>15.5)			
		           		surroundingblock2[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{
	       				surroundingblock2[i].checkstatus=0;

	       				for(int j=0;j<16;j++)
	       				{ 
					   if (Position(surroundingblock2[i])==Position(whitepiececenter[j]))
					   {              surroundingblock2[i].checkstatus=1;
					      break;
					   }
	       				}

	      				for(int j=0;j<16;j++)
	      				{ 
					   if (Position(surroundingblock2[i])==Position(blackpiececenter[j]))
					   {
					     surroundingblock2[i].checkstatus=2;
					     break;
					   }
	      				}
	    	  
	    			}
	   		}
		}
	   	if(obj.GetXPosition()<=obj.GetYPosition())
	   	{
			for(int i=0; i<(obj.GetXPosition()-2.0)/2.0;i++)
	      		{
		              	if(surroundingblock4[i].GetXDistance()<2.0 || surroundingblock4[i].GetYDistance()<1.5 || surroundingblock4[i].GetXDistance()>16.0 || surroundingblock4[i].GetYDistance()>15.5)			
		           		surroundingblock4[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{
					surroundingblock4[i].checkstatus=0;

					for(int j=0;j<16;j++)
					{ 
					    if (Position(surroundingblock4[i])==Position(whitepiececenter[j]))
					    {
					      surroundingblock4[i].checkstatus=1;
					      break;
					    }
		 			}

		 			for(int j=0;j<16;j++)
		 			{ 
					    if (Position(surroundingblock4[i])==Position(blackpiececenter[j]))
					    {
					       surroundingblock4[i].checkstatus=2;
					       break;
					    }
		  			}
	     			}
	    		}
	    	}
	    	else
	    	{

	      		for(int i=0; i<(((1.5+7*2.0)-obj.GetYPosition())/2.0);i++)
	      		{
		      		if(surroundingblock4[i].GetXDistance()<2.0 || surroundingblock4[i].GetYDistance()<1.5 || surroundingblock4[i].GetXDistance()>16.0 || surroundingblock4[i].GetYDistance()>15.5)			
		           		surroundingblock4[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{	
					surroundingblock4[i].checkstatus=0;
	
					for(int j=0;j<16;j++)
					{ 
					    if (Position(surroundingblock4[i])==Position(whitepiececenter[j]))
					    {
					      surroundingblock4[i].checkstatus=1;
					      break;
					    }
		 			}

		 			for(int j=0;j<16;j++)
		 			{ 
					    if (Position(surroundingblock4[i])==Position(blackpiececenter[j]))
					    {
					       surroundingblock4[i].checkstatus=2;
					       break;
					    }
		  			}
	     			}
	    		}
		}
	    	if(obj.GetXPosition()>=obj.GetYPosition())
	    	{
	       		for(int i=0; i<(((2.0+7*2.0)-obj.GetXPosition())/2.0); i++)
	     		{
		       		if(surroundingblock3[i].GetXDistance()<2.0 || surroundingblock3[i].GetYDistance()<1.5 || surroundingblock3[i].GetXDistance()>16.0 || surroundingblock3[i].GetYDistance()>15.5)			
		           		surroundingblock3[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{
	       				surroundingblock3[i].checkstatus=0;

	       				for(int j=0;j<16;j++)
	       				{ 
					   if (Position(surroundingblock3[i])==Position(whitepiececenter[j]))
					   {
					      surroundingblock3[i].checkstatus=1;
					      break;
					   }
	       				}

	      				for(int j=0;j<16;j++)
	      				{ 
					   if (Position(surroundingblock3[i])==Position(blackpiececenter[j]))
					   {
					     surroundingblock3[i].checkstatus=2;
					     break;
					   }
	      				}
	      			}
	     		}
	    	}
	    	else
	     	{
	     		for(int i=0;  i<(obj.GetYPosition()-1.5)/2.0; i++)
	     		{
		     		if(surroundingblock3[i].GetXDistance()<2.0 || surroundingblock3[i].GetYDistance()<1.5 || surroundingblock3[i].GetXDistance()>16.0 || surroundingblock3[i].GetYDistance()>15.5)			
		           		surroundingblock3[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{
	       				surroundingblock3[i].checkstatus=0;

	       				for(int j=0;j<16;j++)
	       				{ 
					   if (Position(surroundingblock3[i])==Position(whitepiececenter[j]))
					   {
					      surroundingblock3[i].checkstatus=1;
					      break;
					   }
	       				}
		
	      				for(int j=0;j<16;j++)
	      				{ 
					   if (Position(surroundingblock3[i])==Position(blackpiececenter[j]))
					   {
					     surroundingblock3[i].checkstatus=2;
					     break;
					   }
	      				}
	      
	     			}
	    		}
		}
	}
	// Getting all valid moves
	void validate()
	{
		int c=0;
	    	if(obj.GetXPosition()>=obj.GetYPosition())
	    	{
	   
			for(int i=0; i<(((2.0+2.0*7)-obj.GetXPosition())/2.0); i++)
			{
				if (surroundingblock1[i].checkstatus==0)
				{
					validmoves[c]= surroundingblock1[i];
					c++;
				}

				else if (surroundingblock1[i].checkstatus==2)
				{
					validmoves[c]= surroundingblock1[i];
					c++;
					break;
				}

				else
				{
					break;
				}
			}
	     }
	     else
	     {      	for(int i=0; i<(((1.5+2.0*7)-obj.GetYPosition())/2.0); i++)
		    	{
			      if (surroundingblock1[i].checkstatus==0)
			      {
				validmoves[c]= surroundingblock1[i];
				c++;
			      }

			      else if (surroundingblock1[i].checkstatus==2)
			      {
				validmoves[c]= surroundingblock1[i];
				c++;
				break;
			      }

			      else
			      {
				break;
			      }
		    	}
	     }
	     if(obj.GetXPosition()<=obj.GetYPosition())
	     {

		    for(int i=0; i<(obj.GetXPosition()-2.0)/2.0; i++)
		    {
			      if (surroundingblock2[i].checkstatus==0)
			      {
				validmoves[c]= surroundingblock2[i];
			    	c++;
			      }

			      else if (surroundingblock2[i].checkstatus==2)
			      {
				validmoves[c]= surroundingblock2[i];
				c++;
				break;
			      }

			      else
			      {
				break;
			      }
		    }
	    }

	    else
	    {       for(int i=0; i<(obj.GetYPosition()-1.5)/2.0; i++) 
		    {
		      if (surroundingblock2[i].checkstatus==0)
		      {
			validmoves[c]= surroundingblock2[i];
			c++;
		     	}

		      else if (surroundingblock2[i].checkstatus==2)
		      {
			validmoves[c]= surroundingblock2[i];
			c++;
			break;
		      }

		      else
		      {
			break;
		      }
		    }
	    }
	    if(obj.GetXPosition()>=obj.GetYPosition())
	    {         
		      for(int i=0; i<(((2.0+2.0*7)-obj.GetXPosition())/2.0); i++)
		      {
			      if (surroundingblock3[i].checkstatus==0)
			      {
				validmoves[c]= surroundingblock3[i];
				c++;
			      }

			      else if (surroundingblock3[i].checkstatus==2)
			      {
				validmoves[c]= surroundingblock3[i];
				c++;
				break;
			      }

			      else
			      {
				break;
			      }
		    }
	    }

	    else
	    {	   
		      for(int i=0; i<(obj.GetYPosition()-1.5)/2.0; i++)
		      {
			      if (surroundingblock3[i].checkstatus==0)
			      {
		
				validmoves[c]= surroundingblock3[i];
				c++;
			      }

			      else if (surroundingblock3[i].checkstatus==2)
			      {
				validmoves[c]= surroundingblock3[i];
				c++;
				break;
			      }

			      else
			      {
				break;
			      }
		    }
	    }

	    if(obj.GetXPosition()>=obj.GetYPosition())
	    { 
		    for(int i=0; i<(((1.5+7*2.0)-obj.GetYPosition())/2.0);i++)
		    {
			      if (surroundingblock4[i].checkstatus==0)
			      {
				validmoves[c]= surroundingblock4[i];
				c++;
			      }

			      else if (surroundingblock2[i].checkstatus==2)
			      {
				validmoves[c]= surroundingblock4[i];
				c++;
				break;
			      }

			      else
			      {
				break;
			      }
		    }
	     }
	 
	    else
	    {       for(int i=0; i<(obj.GetXPosition()-2.0)/2.0; i++)
		    {
			      if (surroundingblock4[i].checkstatus==0)
			      {
				validmoves[c]= surroundingblock4[i];
				c++;
			      }

			      else if (surroundingblock4[i].checkstatus==2)
			      {
				validmoves[c]= surroundingblock4[i];
				c++;
				break;
			      }

			      else
			      {
				break;
			      }
		    }
	    }
	 
	  }
	  
	  int compare(Position c)                  //this function finds out whetehr the click made lies in the valid moves or not
		{
		  int flag=0;
		  	for(int i=0;i<14;i++)
			{	
				if(validmoves[i].checkstatus!=-1)
				{
					if(Position(c)==Position(validmoves[i]))
					{
						if(validmoves[i].checkstatus==0)
						{
							flag=1;
							break;
						}
						else if(validmoves[i].checkstatus==2)
						{
							flag=2;
							break;
						}
					}
				}
			}	
		   
		   return flag;	
		}

	}wb1,wb2;


	     

	class bbishopmove
	{
	  public:
	  //data members
	  BitMap obj;
	  int temp; // temp=0 when it can move 1 sides, temp=1 when it can move 2 sides, and temp=2 when it can move all 4 sides  
	  int move; // move=0 bishop hasnt moved yet     move=1 bishop has moved atleast once
	  int life; // life=0 if dead and life=1 if alive
	  newpos surroundingblock1[7];
	  newpos surroundingblock2[7];
	  newpos surroundingblock3[7];
	  newpos surroundingblock4[7];
	  newpos validmoves[14];
	  //member functions

	// Entering positions of surrounding blocks
	  void initialise()
	  {
	      for(int i=obj.GetXPosition()+2.0,j=obj.GetYPosition()+2.0,c=0; i<=2.0+2.0*7,j<=1.5+7*2.0; i+=2.0,j+=2.0,c++)
	      {
		surroundingblock1[c].SetXDistance(i);
		surroundingblock1[c].SetYDistance(j);
	      }
	  
	      for(int i=obj.GetXPosition()-2.0,j=obj.GetYPosition()-2.0,c=0; i>=2.0,j>=1.5; i-=2.0,j-=2.0,c++)
	      {
		surroundingblock2[c].SetXDistance(i);
		surroundingblock2[c].SetYDistance(j);
	      }
	 
	      for(int i=obj.GetXPosition()+2.0,j=obj.GetYPosition()-2.0,c=0;i<=2.0+2.0*7 ,j>=1.5; i+=2.0,j-=2.0,c++)
	      {
		surroundingblock3[c].SetXDistance(i);
		surroundingblock3[c].SetYDistance(j);
	      }
	   
	      for(int i=obj.GetXPosition()-2.0,j=obj.GetYPosition()+2.0,c=0; i>=2.0,j<=1.5+2.0*7; i-=2.0,j+=2.0,c++)
	      {
		surroundingblock4[c].SetXDistance(i);
		surroundingblock4[c].SetYDistance(j);
	      } 
	  }

	  // Getting value of checkstatus for each block 
	  void checkposition()
	  {
	  	if(obj.GetXPosition()>=obj.GetYPosition())
	   	{
		     
	    		for(int i=0; i<(((2.0+2.0*7)-obj.GetXPosition())/2.0); i++)
	    		{
		    		if(surroundingblock1[i].GetXDistance()<2.0 || surroundingblock1[i].GetYDistance()<1.5 || surroundingblock1[i].GetXDistance()>16.0 || surroundingblock1[i].GetYDistance()>15.5)			
		           		surroundingblock1[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{

					surroundingblock1[i].checkstatus=0;

					for(int j=0;j<16;j++)
					{ 
					    if (Position(surroundingblock1[i])==Position(whitepiececenter[j]))
					    {
					      surroundingblock1[i].checkstatus=2;
					      break;
					    }
					 }

					 for(int j=0;j<16;j++)
					 { 
					    if (Position(surroundingblock1[i])==Position(blackpiececenter[j]))
					    {
					       surroundingblock1[i].checkstatus=1;
					       break;
					    }
					 }
	     			}
	    		}
	    	}
	    	else
	    	{
	      		for(int i=0; i<(((1.5+2.0*7)-obj.GetYPosition())/2.0); i++)
	    		{
		      		if(surroundingblock1[i].GetXDistance()<2.0 || surroundingblock1[i].GetYDistance()<1.5 || surroundingblock1[i].GetXDistance()>16.0 || surroundingblock1[i].GetYDistance()>15.5)			
		           		surroundingblock1[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{

					surroundingblock1[i].checkstatus=0;

					for(int j=0;j<16;j++)
					{ 
					    if (Position(surroundingblock1[i])==Position(whitepiececenter[j]))
					    {
					      surroundingblock1[i].checkstatus=2;
					      break;
					    }
					 }

					 for(int j=0;j<16;j++)
					 { 
					    if (Position(surroundingblock1[i])==Position(blackpiececenter[j]))
					    {
					       surroundingblock1[i].checkstatus=1;
					       break;
					    }
					 }
	     			}
	    		}
		}

	  	if(obj.GetXPosition()<=obj.GetYPosition())
	  	{
		 	for(int i=0; i<(obj.GetXPosition()-2.0)/2.0; i++)
	    		{
		 		if(surroundingblock2[i].GetXDistance()<2.0 || surroundingblock2[i].GetYDistance()<1.5 || surroundingblock2[i].GetXDistance()>16.0 || surroundingblock2[i].GetYDistance()>15.5)			
		           		surroundingblock2[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{

	       				surroundingblock2[i].checkstatus=0;

	       				for(int j=0;j<16;j++)
				       { 
					   if (Position(surroundingblock2[i])==Position(whitepiececenter[j]))
					   {
					      surroundingblock2[i].checkstatus=2;
					      break;
					   }
				       }

				      for(int j=0;j<16;j++)
				      { 
					   if (Position(surroundingblock2[i])==Position(blackpiececenter[j]))
					   {
					     surroundingblock2[i].checkstatus=1;
					     break;
					   }
				      }
	      
	    			}
	   		}
		}
	   	else
	   	{

	    		for(int i=0; i<(obj.GetYPosition()-1.5)/2.0; i++)
	    		{
		  		if(surroundingblock2[i].GetXDistance()<2.0 || surroundingblock2[i].GetYDistance()<1.5 || surroundingblock2[i].GetXDistance()>16.0 || surroundingblock2[i].GetYDistance()>15.5)			
		           		surroundingblock2[i].checkstatus=-1; // the move is out of the chessboard			
				else	
				{
				       surroundingblock2[i].checkstatus=0;

				       for(int j=0;j<16;j++)
				       { 
					   if (Position(surroundingblock2[i])==Position(whitepiececenter[j]))
					   {              surroundingblock2[i].checkstatus=2;
					      break;
					   }
				       }

				      for(int j=0;j<16;j++)
				      { 
					   if (Position(surroundingblock2[i])==Position(blackpiececenter[j]))
					   {
					     surroundingblock2[i].checkstatus=1;
					     break;
					   }
				      }
	      
   	 			}
	   		}
		}
	   	if(obj.GetXPosition()<=obj.GetYPosition())
	   	{
		     	for(int i=0; i<(obj.GetXPosition()-2.0)/2.0;i++)
	      		{
		              	if(surroundingblock4[i].GetXDistance()<2.0 || surroundingblock4[i].GetYDistance()<1.5 || surroundingblock4[i].GetXDistance()>16.0 || surroundingblock4[i].GetYDistance()>15.5)			
		           		surroundingblock4[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{
					surroundingblock4[i].checkstatus=0;

					for(int j=0;j<16;j++)
					{ 
					    if (Position(surroundingblock4[i])==Position(whitepiececenter[j]))
					    {
					      surroundingblock4[i].checkstatus=2;
					      break;
					    }
					}

					for(int j=0;j<16;j++)
					{ 
					    if (Position(surroundingblock4[i])==Position(blackpiececenter[j]))
					    {
					       surroundingblock4[i].checkstatus=1;
					       break;
					    }
					}
	     			}
	    		}
	    	}
	    	else
	    	{

	      		for(int i=0; i<(((1.5+7*2.0)-obj.GetYPosition())/2.0);i++)
	      		{
		      		if(surroundingblock4[i].GetXDistance()<2.0 || surroundingblock4[i].GetYDistance()<1.5 || surroundingblock4[i].GetXDistance()>16.0 || surroundingblock4[i].GetYDistance()>15.5)			
		           		surroundingblock4[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{
					surroundingblock4[i].checkstatus=0;

					for(int j=0;j<16;j++)
					{ 
					    if (Position(surroundingblock4[i])==Position(whitepiececenter[j]))
					    {
					      surroundingblock4[i].checkstatus=2;
					      break;
					    }
					}

					for(int j=0;j<16;j++)
					{ 
					    if (Position(surroundingblock4[i])==Position(blackpiececenter[j]))
					    {
					       surroundingblock4[i].checkstatus=1;
					       break;
					    }
					}
	     			}
	    		}
		}
	    	if(obj.GetXPosition()>=obj.GetYPosition())
	    	{
	       		for(int i=0; i<(((2.0+7*2.0)-obj.GetXPosition())/2.0); i++)
	     		{
		       		if(surroundingblock3[i].GetXDistance()<2.0 || surroundingblock3[i].GetYDistance()<1.5 || surroundingblock3[i].GetXDistance()>16.0 || surroundingblock3[i].GetYDistance()>15.5)			
		           		surroundingblock3[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{
				       surroundingblock3[i].checkstatus=0;

				       for(int j=0;j<16;j++)
				       { 
					   if (Position(surroundingblock3[i])==Position(whitepiececenter[j]))
					   {
					      surroundingblock3[i].checkstatus=2;
					      break;
					   }
				       }

				      for(int j=0;j<16;j++)
				      { 
					   if (Position(surroundingblock3[i])==Position(blackpiececenter[j]))
					   {
					     surroundingblock3[i].checkstatus=1;
					     break;
					   }
				      }
	      			}
	     		}
	    	}
	    	else
	     	{
	     		for(int i=0;  i<(obj.GetYPosition()-1.5)/2.0; i++)
	     		{
		     		if(surroundingblock3[i].GetXDistance()<2.0 || surroundingblock3[i].GetYDistance()<1.5 || surroundingblock3[i].GetXDistance()>16.0 || surroundingblock3[i].GetYDistance()>15.5)			
		           		surroundingblock3[i].checkstatus=-1; // the move is out of the chessboard			
				else
				{
				       surroundingblock3[i].checkstatus=0;

				       for(int j=0;j<16;j++)
				       { 
					   if (Position(surroundingblock3[i])==Position(whitepiececenter[j]))
					   {
					      surroundingblock3[i].checkstatus=2;
					      break;
					   }
				       }

				      for(int j=0;j<16;j++)
				      { 
					   if (Position(surroundingblock3[i])==Position(blackpiececenter[j]))
					   {
					     surroundingblock3[i].checkstatus=1;
					     break;
					   }
				      }
	      
	     			}
	    		}
		}
	}
	    // Getting all valid moves
	void validate()
	{ 
	int c=0;
		if(obj.GetXPosition()>=obj.GetYPosition())
	    	{
	   
		    for(int i=0; i<(((2.0+2.0*7)-obj.GetXPosition())/2.0); i++)
		    {
		      if (surroundingblock1[i].checkstatus==0)
		      {
			validmoves[c]= surroundingblock1[i];
				c++;
		      }

		      else if (surroundingblock1[i].checkstatus==2)
		      {
			validmoves[c]= surroundingblock1[i];
			c++;
			break;
		      }

		      else
		      {
			break;
		      }
		    }
	     	}
	     	else
	     	{
		    for(int i=0; i<(((1.5+2.0*7)-obj.GetYPosition())/2.0); i++)
		    {
		      if (surroundingblock1[i].checkstatus==0)
		      {
			validmoves[c]= surroundingblock1[i];
			c++;
		      }

		      else if (surroundingblock1[i].checkstatus==2)
		      {
			validmoves[c]= surroundingblock1[i];
			c++;
			break;
		      }

		      else
		      {
			break;
		      }
		    }
	     	}
	    	if(obj.GetXPosition()<=obj.GetYPosition())
	    	{

		    for(int i=0; i<(obj.GetXPosition()-2.0)/2.0; i++)
		    {
		      if (surroundingblock2[i].checkstatus==0)
		      {
			validmoves[c]= surroundingblock2[i];
		    	c++;
		      }

		      else if (surroundingblock2[i].checkstatus==2)
		      {
			validmoves[c]= surroundingblock2[i];
			c++;
			break;
		      }

		      else
		      {
			break;
		      }
		    }
	    	}

	    	else
	    	{
		    for(int i=0; i<(obj.GetYPosition()-1.5)/2.0; i++) 
		    {
		      if (surroundingblock2[i].checkstatus==0)
		      {
			validmoves[c]= surroundingblock2[i];
				c++;
		     }

		      else if (surroundingblock2[i].checkstatus==2)
		      {
			validmoves[c]= surroundingblock2[i];
			c++;
			break;
		      }

		      else
		      {
			break;
		      }
		    }
		}
	    	if(obj.GetXPosition()>=obj.GetYPosition())
	    	{
		    for(int i=0; i<(((2.0+2.0*7)-obj.GetXPosition())/2.0); i++)
		    {
		      if (surroundingblock3[i].checkstatus==0)
		      {
			validmoves[c]= surroundingblock3[i];
			c++;
		      }

		      else if (surroundingblock3[i].checkstatus==2)
		      {
			validmoves[c]= surroundingblock3[i];
			c++;
			break;
		      }

		      else
		      {
			break;
		      }
		    }
	    }

	    else
	    {	   
		      for(int i=0; i<(obj.GetYPosition()-1.5)/2.0; i++)
		      {
			      if (surroundingblock3[i].checkstatus==0)
			      {
		
				validmoves[c]= surroundingblock3[i];
				c++;
			      }

			      else if (surroundingblock3[i].checkstatus==2)
			      {
				validmoves[c]= surroundingblock3[i];
				c++;
				break;
			      }

			      else
			      {
				break;
			      }
		    }
	    }

	    if(obj.GetXPosition()>=obj.GetYPosition())
	    { 
		    for(int i=0; i<(((1.5+7*2.0)-obj.GetYPosition())/2.0);i++)
		    {
		      if (surroundingblock4[i].checkstatus==0)
		      {
			validmoves[c]= surroundingblock4[i];
			c++;
		      }

		      else if (surroundingblock2[i].checkstatus==2)
		      {
			validmoves[c]= surroundingblock4[i];
			c++;
			break;
		      }

		      else
		      {
			break;
		      }
		    }
	     }
	 
	    else
	    {       for(int i=0; i<(obj.GetXPosition()-2.0)/2.0; i++)
		    {
		      if (surroundingblock4[i].checkstatus==0)
		      {
			validmoves[c]= surroundingblock4[i];
			c++;
		      }

		      else if (surroundingblock4[i].checkstatus==2)
		      {
			validmoves[c]= surroundingblock4[i];
			c++;
			break;
		      }

		      else
		      {
			break;
		      }
		    }
	    }
	 
	  }
	  
	  int compare(Position c)                  //this function finds out whetehr the click made lies in the valid moves or not
		{
		  int flag=0;
		  	for(int i=0;i<14;i++)
			{	
				if(validmoves[i].checkstatus!=-1)
				{
					if(Position(c)==Position(validmoves[i]))
					{
						if(validmoves[i].checkstatus==0)
						{
							flag=1;
							break;
						}
						else if(validmoves[i].checkstatus==2)
						{
							flag=2;
							break;
						}
					}
				}
			}	
		   
		   return flag;	
		}


	}bb1,bb2;






                      
//_________________________________________________________________*****____________________________________________________//


//defining functions
//this function assigns center of each cell in the chessboard to an array and adds a corresponding unique cell address to it
	void createboard()       
	{      
		 int i,w1,w2;
		 //char chrctr;
		 for(int i=0,w1=0,w2=0 ; i<8 ; i++)
		 {
			for(int j=0;j<8;j++)
			{
				board[i][j].SetXDistance(2.0+w1);
				board[i][j].SetYDistance(1.5+w2);
				//board[i][j].hcor=chrctr;
				//board[i][j].vcor=n;
				//n++;
				w1=w1+2.0;
				
			}
			w2=w2+2.0;
			//n=1;
			//chrctr++;
			w1=0;

		  }
	}


  

	void drawchessboard()        //function to draw the chessboard
	{
	//creating rectangles for chessboard.
		int i,j;
		float x1,x2,y1,y2;
		Position center;
		Position centers[8][8];
		centers[0][0]=center;
		for(int i=0;i<8;i++)
		{
			for(int j=0;j<8;j++)
			{
				x1=2+i*2.0;
				y1=1.5+j*2.0;
				center.SetXDistance(x1);
				center.SetYDistance(y1); 
				centers[i][j]=center;
				if((i+j)%2==0)
				{
				  RectangleShape rect(windowptr, center, White, 2, 2);
				  rect.Draw();
				}
				else
				{
				  RectangleShape rect(windowptr, center, Red, 2, 2);
				  rect.Draw();
				}
			}
		}
	}



  
	void assigncenters()   //this function assigns the centers of pieces in two respective arrays for black and white pieces
	{
		whitepiececenter[0]=wpawn1.GetPosition();
		whitepiececenter[1]=wpawn2.GetPosition();
		whitepiececenter[2]=wpawn3.GetPosition();
		whitepiececenter[3]=wpawn4.GetPosition();
		whitepiececenter[4]=wpawn5.GetPosition();
		whitepiececenter[5]=wpawn6.GetPosition();
		whitepiececenter[6]=wpawn7.GetPosition();
		whitepiececenter[7]=wpawn8.GetPosition();
		whitepiececenter[8]=wking.GetPosition();
		whitepiececenter[9]=wqueen.GetPosition();
		whitepiececenter[10]=wknight1.GetPosition();
		whitepiececenter[11]=wknight2.GetPosition();
		whitepiececenter[12]=wbishopleft.GetPosition();
		whitepiececenter[13]=wbishopright.GetPosition();
		whitepiececenter[14]=wrook1.GetPosition();
		whitepiececenter[15]=wrook2.GetPosition();


		blackpiececenter[0]=bpawn1.GetPosition();
		blackpiececenter[1]=bpawn2.GetPosition();
		blackpiececenter[2]=bpawn3.GetPosition();
		blackpiececenter[3]=bpawn4.GetPosition();
		blackpiececenter[4]=bpawn5.GetPosition();
		blackpiececenter[5]=bpawn6.GetPosition();
		blackpiececenter[6]=bpawn7.GetPosition();
		blackpiececenter[7]=bpawn8.GetPosition();
		blackpiececenter[8]=bking.GetPosition();
		blackpiececenter[9]=bqueen.GetPosition();
		blackpiececenter[10]=bknight1.GetPosition();
		blackpiececenter[11]=bknight2.GetPosition();
		blackpiececenter[12]=bbishopleft.GetPosition();
		blackpiececenter[13]=bbishopright.GetPosition();
		blackpiececenter[14]=brook1.GetPosition();
		blackpiececenter[15]=brook2.GetPosition();
	}





	int givepiece(const Position &p)     //this function returns piece selected when a click is made
	{	
							
		int k;
		if(x%2==1)
		{tell=-1;
			for(int i=0;i<8;i++)
			{
				for(int j=0;j<8;j++)
				{
				  if(p.GetXDistance()>1+(2*j) && p.GetXDistance()<1+(2*(j+1)) && p.GetYDistance()>0.5+(2*i) && p.GetYDistance()<0.5+(2*(i+1)))
				     {
						for(k=0;k<16;k++)
						{
								if(whitepiececenter[k].GetXDistance()>1+(2*j) && whitepiececenter[k].GetXDistance()<1+(2*(j+1)) && whitepiececenter[k].GetYDistance()>0.5+(2*i) && whitepiececenter[k].GetYDistance()<0.5+(2*(i+1)))
								{
									tell=k;
									 windowptr.RenderText(Position(22.0,8.0), Position(23.0,8.0) , "                             ", Red);								
									break;
								}
								else if(blackpiececenter[k].GetXDistance()>1+(2*j) && blackpiececenter[k].GetXDistance()<1+(2*(j+1)) && blackpiececenter[k].GetYDistance()>0.5+(2*i) && blackpiececenter[k].GetYDistance()<0.5+(2*(i+1)))
								{
									tell=k+16;
									 windowptr.RenderText(Position(22.0,8.0), Position(23.0,8.0) , "                             ", Red);									break;
								}
							
					 	}
						if(tell==-1)
						{
						windowptr.RenderText(Position(22.0,8.0), Position(23.0,8.0) , "Please, select a piece!", Red);
						return 1;
						}
				      }			
				}
			} 
		}
		else if(x%2==0)
		{
			int temp,res;
			
						
			for(int i=0;i<8;i++)
			{
				for(int j=0;j<8;j++)
				{
				  if(p.GetXDistance()>1+(2*j) && p.GetXDistance()<1+(2*(j+1)) && p.GetYDistance()>0.5+(2*i) && p.GetYDistance()<0.5+(2*(i+1)))
				  {
					place.SetXDistance(board[i][j].GetXDistance()-0.85);
					place.SetYDistance(board[i][j].GetYDistance()-0.85);
					break;
				  }
				}	
			}
			switch(tell)
			{
				case 0 :	piece=wpawn1;
						wp1.initialise();
				     		wp1.checkposition();
				     		wp1.validate();
						res=wp1.compare(place);
					 	break;
				case 1 : 	piece=wpawn2;
					 	wp2.initialise();
				     		wp2.checkposition();
				     		wp2.validate();
						res=wp2.compare(place);
					 	break;
				case 2 : 	piece=wpawn3;
					 	wp3.initialise();
				     		wp3.checkposition();
		             			wp3.validate();
						res=wp3.compare(place);
					 	break;
				case 3 : 	piece=wpawn4;
					     	wp4.initialise();
				     		wp4.checkposition();
		             			wp4.validate();
						res=wp4.compare(place);
						//res=1;
		         			break;
				case 4 : 	piece=wpawn5;
					 	wp5.initialise();
				     		wp5.checkposition();
		             			wp5.validate();
						res=wp5.compare(place);
					 	break;
				case 5 : 	piece=wpawn6;
					 	wp6.initialise();
				     		wp6.checkposition();
		             			wp6.validate();
						res=wp6.compare(place);
						break;
				case 6 : 	piece=wpawn7;
					    	wp7.initialise();
				     		wp7.checkposition();
		             			wp7.validate();
						res=wp7.compare(place);
		         			break;
				case 7 : 	piece=wpawn8;
					 	wp8.initialise();
				     		wp8.checkposition();
		             			wp8.validate();
						res=wp8.compare(place);
					 	break;
				case 8 : 	piece=wking;
					     	wk.initialise();
				     		wk.checkposition();
		             			wk.validate();
						res=wk.compare(place);
		         			break;
				case 9 : 	piece=wqueen;
					     	wq.initialise();
				     		wq.checkposition();
		             			wq.validate();
						res=wq.compare(place);
		         			break;
				case 10 : 	piece=wknight1;
		             			wkn1.initialise();
				     		wkn1.checkposition();
		             			wkn1.validate();
						res=wkn1.compare(place);
		         			break;
				case 11 : 	piece=wknight2;
					      	wkn2.initialise();
				      		wkn2.checkposition();
		              			wkn2.validate();
						res=wkn2.compare(place);
		         			break;
				case 12 : 	piece=wbishopleft;
					      	wb1.initialise();
				     		wb1.checkposition();
		              			wb1.validate();
						res=wb1.compare(place);
		         			break;
				case 13 : 	piece=wbishopright;
					      	wb2.initialise();
				      		wb2.checkposition();
		              			wb2.validate();
						res=wb2.compare(place);
		         			break;
				case 14 : 	piece=wrook1;
					      	wr1.initialise();
				      		wr1.checkposition();
			       			wr1.validate();
						res=wr1.compare(place);
		         			break;
				case 15 : 	piece=wrook2;
					  	wr2.initialise();
				      		wr2.checkposition();
		              			wr2.validate();
						res=wr2.compare(place);
					 	break;
				case 16 : 	piece=bpawn1;
					      	bp1.initialise();
				      		bp1.checkposition();
		              			bp1.validate();
						res=bp1.compare(place);
		         			break;
				case 17 : 	piece=bpawn2;
					      	bp2.initialise();
				      		bp2.checkposition();
		              			bp2.validate();
						res=bp2.compare(place);
		         			break;
				case 18 : 	piece=bpawn3;
					  	bp3.initialise();
				      		bp3.checkposition();
		              			bp3.validate();
						res=bp3.compare(place);
					 	break;
				case 19 : 	piece=bpawn4;
					  	bp4.initialise();
				      		bp4.checkposition();
		              			bp4.validate();
						res=bp4.compare(place);
					 	break;
				case 20 : 	piece=bpawn5;
					      	bp5.initialise();
				      		bp5.checkposition();
		              			bp5.validate();
						res=bp5.compare(place);
		         			break;
				case 21 : 	piece=bpawn6;
					 	bp6.initialise();
				      		bp6.checkposition();
		              			bp6.validate();
						res=bp6.compare(place);
					 	break;
				case 22 : 	piece=bpawn7;
					  	bp7.initialise();
				      		bp7.checkposition();
		              			bp7.validate();
						res=bp7.compare(place);
					 	break;
				case 23 : 	piece=bpawn8;
					  	bp8.initialise();
				      		bp8.checkposition();
		              			bp8.validate();
						res=bp8.compare(place);
					 	break;
				case 24 : 	piece=bking;
					  	bk.initialise();
				      		bk.checkposition();
		              			bk.validate();
						res=bk.compare(place);
					 	break;
				case 25 : 	piece=bqueen;
					  	bq.initialise();
				      		bq.checkposition();
		              			bq.validate();
						res=bq.compare(place);
					 	break;
				case 26 : 	piece=bknight1;
					  	bkn1.initialise();
				      		bkn1.checkposition();
		              			bkn1.validate();
						res=bkn1.compare(place);
					 	break;
				case 27 : 	piece=bknight2;
					  	bkn2.initialise();
				      		bkn2.checkposition();
		              			bkn2.validate();
						res=bkn2.compare(place);
					 	break;
				case 28 : 	piece=bbishopleft;
					      	bb1.initialise();
				      		bb1.checkposition();
		              			bb1.validate();
						res=bb1.compare(place);
		         			break;
				case 29 : 	piece=bbishopright;
					      	bb2.initialise();
				      		bb2.checkposition();
		              			bb2.validate();
						res=bb2.compare(place);
		         			break;
				case 30 : 	piece=brook1;
					      	br1.initialise();
				      		br1.checkposition();
		              			br1.validate();
						res=br1.compare(place);
		         			break;
				case 31 : 	piece=brook2;
					      	br2.initialise();
				      		br2.checkposition();
		              			br2.validate();
						res=br2.compare(place);
		         			break;
			}

			if(res==0)
			{
				windowptr.RenderText(Position(22.0,8.0), Position(23.0,8.0) , "Invalid Move!", Red);
			}
			else if (res==1)
			{
				wpawn4.Erase();
				wpawn4.SetPosition(place);
				drawchessboard();
			
			}
			else if(res==2)
			{	
				piece.Erase();
				piece.SetPosition(place);
				drawchessboard();
				for(int i=0;i<8;i++)
				{
					for(int j=0;j<8;j++)
					{				
						for(int k=0;k<16;i++)
						{
							if(whitepiececenter[k].GetXDistance()>1+(2*j) && whitepiececenter[k].GetXDistance()<1+(2*(j+1)) && whitepiececenter[k].GetYDistance()>0.5+(2*i) && whitepiececenter[k].GetYDistance()<0.5+(2*(i+1)))
								{
									temp=k;		
									break;
								}
		
						}
					}
				}
				switch(temp)
				{
					case 0 : wp1.life=0;
						 break;
					case 1 : wp2.life=0;
						 break;
					case 2 : wp3.life=0;
						 break;
					case 3 : wp4.life=0;
						 break;
					case 4 : wp5.life=0;
						 break;
					case 5 : wp6.life=0;
						 break;
					case 6 : wp7.life=0;
						 break;
					case 7 : wp8.life=0;
						 break;
					case 8 : wk.life=0;
						 break;
					case 9 : wq.life=0;
						 break;
					case 10 : wkn1.life=0;
						 break;
					case 11 : wkn2.life=0;
						 break;
					case 12 : wb1.life=0;
						 break;
					case 13 : wb2.life=0;
						 break;
					case 14 : wr1.life=0;
						 break;
					case 15 : wr2.life=0;
						 break;
				}
			}
			else if(res==3)
			{
				piece.Erase();
				piece.SetPosition(place);
				drawchessboard();
				for(int i=0;i<8;i++)
				{
					for(int j=0;j<8;j++)
					{				
						for(int k=0;k<16;i++)
						{
							if(blackpiececenter[k].GetXDistance()>1+(2*j) && blackpiececenter[k].GetXDistance()<1+(2*(j+1)) && blackpiececenter[k].GetYDistance()>0.5+(2*i) && blackpiececenter[k].GetYDistance()<0.5+(2*(i+1)))
								{
									temp=k;		
									break;
								}
		
						}
					}
				}
				switch(temp)
				{
					case 0 : bp1.life=0;
						 break;
					case 1 : bp2.life=0;
						 break;
					case 2 : bp3.life=0;
						 break;
					case 3 : bp4.life=0;
						 break;
					case 4 : bp5.life=0;
						 break;
					case 5 : bp6.life=0;
						 break;
					case 6 : bp7.life=0;
						 break;
					case 7 : bp8.life=0;
						 break;
					case 8 : bk.life=0;
						 break;
					case 9 : bq.life=0;
						 break;
					case 10 :bkn1.life=0;
						 break;
					case 11 :bkn2.life=0;
						 break;
					case 12 :bb1.life=0;
						 break;
					case 13 :bb2.life=0;
						 break;
					case 14 :br1.life=0;
						 break;
					case 15 :br2.life=0;
						 break;
				}
			}
			
			if(wp1.life==1)
				wpawn1.Draw();
			if(wp2.life==1)
				wpawn2.Draw();
			if(wp3.life==1)
				wpawn3.Draw();
			if(wp4.life==1)
				wpawn4.Draw();
			if(wp5.life==1)
				wpawn5.Draw();
			if(wp6.life==1)
				wpawn6.Draw();
			if(wp7.life==1)
				wpawn7.Draw();
			if(wp8.life==1)
				wpawn8.Draw();
			if(wq.life==1)
				wqueen.Draw();
			if(wk.life==1)
				wking.Draw();
			if(wb1.life==1)
				wbishopleft.Draw();
			if(wb2.life==1)
				wbishopright.Draw();
			if(wr1.life==1)
				wrook1.Draw();
			if(wr2.life==1)
				wrook2.Draw();
			if(wkn1.life==1)
				wknight1.Draw();
			if(wkn2.life==1)
				wknight2.Draw();
			if(bp1.life==1)
				bpawn1.Draw();
			if(bp2.life==1)
				bpawn2.Draw();
			if(bp3.life==1)
				bpawn3.Draw();
			if(bp4.life==1)
				bpawn4.Draw();
			if(bp5.life==1)
				bpawn5.Draw();
			if(bp6.life==1)
				bpawn6.Draw();
			if(bp7.life==1)
				bpawn7.Draw();
			if(bp8.life==1)
				bpawn8.Draw();
			if(bk.life==1)
				bking.Draw();
			if(bq.life==1)
				bqueen.Draw();
			if(bb2.life==1)
				bbishopright.Draw();
			if(bb1.life==1)
				bbishopleft.Draw();
			if(bb2.life==1)
				bbishopright.Draw();
			if(br1.life==1)
				brook1.Draw();
			if(br2.life==1)
				brook2.Draw();
			if(bkn1.life==1)
				bknight1.Draw();
			if(bkn2.life==1)
				bknight2.Draw();
			
		}
		x++;
		return 1;
	}



/*
this function checks whether the second click is made on the right position by invoking a function comapre of the defined class. the function compare passes some values.
		value=0         ==>    the square in which the click is made is not a valid move
		value=1         ==>    the square in which the click is made is empty
		value=2         ==>    returned only by black pieces. Shows that the square in which the click is made is occupied by white piece(enemy)
		value=3         ==>    returned only by white pieces. Shows that the square in which the click is made is occupied by black piece(enemy)
accordingly it sets the life variable of that piece to 0 indicating that it is dead and should not be displayed on the board.
Then it draws the remaining required pieces and the chessboard on the screen.
*/

	//int allocate(const Position &p)
	//{
		
			
		
		
	
    


//______________________________________________________________*****___________________________________________________________//	
 





 


int ApiMain()
{

	// Open the windows
	windowptr.Open();
	assert(windowptr.GetStatus() == WindowOpen);

		// Load the images
	
	wbishopleft.Load("wbishopleft.xpm");
	wbishopright.Load("wbishopright.xpm");
	wpawn1.Load("wpawn1.xpm");
	wpawn2.Load("wpawn2.xpm");
	wpawn3.Load("wpawn3.xpm");
	wpawn4.Load("wpawn4.xpm");
	wpawn5.Load("wpawn5.xpm");
	wpawn6.Load("wpawn6.xpm");
	wpawn7.Load("wpawn7.xpm");
	wpawn8.Load("wpawn8.xpm");
	wrook1.Load("wrook1.xpm");
	wrook2.Load("wrook2.xpm");
	wknight1.Load("wknight1.xpm");
	wknight2.Load("wknight2.xpm");	
	wqueen.Load("wqueen.xpm");
	wking.Load("wking.xpm");

	bpawn1.Load("bpawn1.xpm");
	bpawn2.Load("bpawn2.xpm");
	bpawn3.Load("bpawn3.xpm");
	bpawn4.Load("bpawn4.xpm");
	bpawn5.Load("bpawn5.xpm");
	bpawn6.Load("bpawn6.xpm");
	bpawn7.Load("bpawn7.xpm");
	bpawn8.Load("bpawn8.xpm");
	bbishopleft.Load("bbishopleft.xpm");
	bbishopright.Load("bbishopright.xpm");
	brook1.Load("brook1.xpm");
	brook2.Load("brook2.xpm");
	bknight1.Load("bknight1.xpm");
	bknight2.Load("bknight2.xpm");
	bqueen.Load("bqueen.xpm");
	bking.Load("bking.xpm");
	

	//______________________________________________________________*****___________________________________________________________//	
 	


	// checking the loaded images
	assert(wpawn1.GetStatus() == BitMapOkay);
	assert(wpawn2.GetStatus() == BitMapOkay);
	assert(wpawn3.GetStatus() == BitMapOkay);
	assert(wpawn4.GetStatus() == BitMapOkay);
	assert(wpawn5.GetStatus() == BitMapOkay);
	assert(wpawn6.GetStatus() == BitMapOkay);
	assert(wpawn7.GetStatus() == BitMapOkay);
	assert(wpawn8.GetStatus() == BitMapOkay);
	assert(wbishopleft.GetStatus() == BitMapOkay);
	assert(wbishopright.GetStatus() == BitMapOkay);
	assert(wrook1.GetStatus() == BitMapOkay);
	assert(wrook2.GetStatus() == BitMapOkay);
	assert(wknight1.GetStatus() == BitMapOkay);
	assert(wknight2.GetStatus() == BitMapOkay);
	assert(wqueen.GetStatus() == BitMapOkay);
	assert(wking.GetStatus() == BitMapOkay);

	assert(bpawn1.GetStatus() == BitMapOkay);
	assert(bpawn2.GetStatus() == BitMapOkay);
	assert(bpawn3.GetStatus() == BitMapOkay);
	assert(bpawn4.GetStatus() == BitMapOkay);
	assert(bpawn5.GetStatus() == BitMapOkay);
	assert(bpawn6.GetStatus() == BitMapOkay);
	assert(bpawn7.GetStatus() == BitMapOkay);
	assert(bpawn8.GetStatus() == BitMapOkay);
	assert(bbishopleft.GetStatus() == BitMapOkay);
	assert(bbishopright.GetStatus() == BitMapOkay);
	assert(brook1.GetStatus() == BitMapOkay);
	assert(brook2.GetStatus() == BitMapOkay);
	assert(bknight1.GetStatus() == BitMapOkay);
	assert(bknight2.GetStatus() == BitMapOkay);
	assert(bqueen.GetStatus() == BitMapOkay);
	assert(bking.GetStatus() == BitMapOkay);
	
	//______________________________________________________________*****___________________________________________________________//	
 
	
	
	drawchessboard();
		

	// Display the bitmaps at a starting position

	brook1.SetPosition(Position(1.22, 0.59));
	brook1.Draw();
	bknight1.SetPosition(Position(3.22, 0.75));
	bknight1.Draw();
	bbishopleft.SetPosition(Position(5.22, 0.70));
	bbishopleft.Draw();
	bqueen.SetPosition(Position(7.22, 0.75));
	bqueen.Draw();
	bking.SetPosition(Position(9.22, 0.75));
	bking.Draw();
	bbishopright.SetPosition(Position(11.22, 0.70));
	bbishopright.Draw();
	bknight2.SetPosition(Position(13.22, 0.75));
	bknight2.Draw();
	brook2.SetPosition(Position(15.22, 0.59));
	brook2.Draw();
	bpawn1.SetPosition(Position(1.25, 2.75));
	bpawn1.Draw();
	bpawn2.SetPosition(Position(3.25, 2.75));
	bpawn2.Draw();
	bpawn3.SetPosition(Position(5.25, 2.75));
	bpawn3.Draw();
	bpawn4.SetPosition(Position(7.25, 2.75));
	bpawn4.Draw();
	bpawn5.SetPosition(Position(9.25, 2.75));
	bpawn5.Draw();
	bpawn6.SetPosition(Position(11.25, 2.75));
	bpawn6.Draw();
	bpawn7.SetPosition(Position(13.25, 2.75));
	bpawn7.Draw();
	bpawn8.SetPosition(Position(15.25, 2.75));
	bpawn8.Draw();
	
    wknight1.SetPosition(Position(3.2, 14.85));
    wknight1.Draw();
    wknight2.SetPosition(Position(13.2, 14.85));
    wknight2.Draw();

    wrook1.SetPosition(Position(1.2, 14.59));
    wrook1.Draw();
    wrook2.SetPosition(Position(15.2, 14.59));
    wrook2.Draw();

    wbishopright.SetPosition(Position(11.2, 14.85));
    wbishopright.Draw();
    wbishopleft.SetPosition(Position(5.2, 14.85));
    wbishopleft.Draw();

    wqueen.SetPosition(Position(7.2, 14.85));
    wqueen.Draw();
    wking.SetPosition(Position(9.2, 14.85));
    wking.Draw();

    wpawn1.SetPosition(Position(1.2, 12.85));
    wpawn1.Draw();
    wpawn2.SetPosition(Position(3.2, 12.85));
    wpawn2.Draw();
    wpawn3.SetPosition(Position(5.2, 12.85));
    wpawn3.Draw();
    wpawn4.SetPosition(Position(7.2, 12.85));
    wpawn4.Draw();
    wpawn5.SetPosition(Position(9.2, 12.85));
    wpawn5.Draw();
	wpawn6.SetPosition(Position(11.2, 12.85));
    wpawn6.Draw();
    wpawn7.SetPosition(Position(13.2, 12.85));
    wpawn7.Draw();
    wpawn8.SetPosition(Position(15.2, 12.85));
    wpawn8.Draw();

	//______________________________________________________________*****___________________________________________________________//	
 
	
		bp1.obj=bpawn1;
		bp2.obj=bpawn2;
		bp3.obj=bpawn3;
		bp4.obj=bpawn4;
		bp5.obj=bpawn5;
		bp6.obj=bpawn6;
		bp7.obj=bpawn7;
		bp8.obj=bpawn8;
		bq.obj=bqueen;
		br1.obj=brook1;
		br2.obj=brook2;
		bk.obj=bking;
		bkn1.obj=bknight1;
		bkn2.obj=bknight2;
		bb1.obj=bbishopleft;
		bb2.obj=bbishopright;
		wp1.obj=wpawn1;
		wp2.obj=wpawn2;
		wp3.obj=wpawn3;
		wp4.obj=wpawn4;
		wp5.obj=wpawn5;
		wp6.obj=wpawn6;
		wp7.obj=wpawn7;
		wp8.obj=wpawn8;
		wq.obj=wqueen;
		wr1.obj=wrook1;
		wr2.obj=wrook2;
		wk.obj=wking;
		wkn1.obj=wknight1;
		wkn2.obj=wknight2;
		wb1.obj=wbishopleft;
		wb2.obj=wbishopright;
			
		bp1.life=1;
		bp2.life=1;
		bp3.life=1;
		bp4.life=1;
		bp5.life=1;
		bp6.life=1;
		bp7.life=1;
		bp8.life=1;
		bq.life=1;
		br1.life=1;
		br2.life=1;
		bk.life=1;
		bkn1.life=1;
		bkn2.life=1;
		bb1.life=1;
		bb2.life=1;
		wp1.life=1;
		wp2.life=1;
		wp3.life=1;
		wp4.life=1;
		wp5.life=1;
		wp6.life=1;
		wp7.life=1;
		wp8.life=1;
		wq.life=1;
		wr1.life=1;
		wr2.life=1;
		wk.life=1;
		wkn1.life=1;
		wkn2.life=1;
		wb1.life=1;
		wb2.life=1;	



	createboard();
	assigncenters();
	
	windowptr.SetMouseClickCallback(givepiece);
	//windowptr.SetMouseClickCallback(allocate);
	
	return 0;		
}